// ArgusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Argus.h"
#include "ArgusDlg.h"
#include "OptionsDlg.h"
#include "console.h"
#include "cgame.h"
#include "options.h"
#include "statistics.h"
#include "threads.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArgusDlg dialog

CArgusDlg::CArgusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArgusDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArgusDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArgusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArgusDlg)
	DDX_Control(pDX, IDC_TABPOSHELPER, m_TabPosHelper);
	DDX_Control(pDX, IDC_MAINDIALOGTAB, m_MainTab);
	DDX_Control(pDX, IDC_DISCONNECT, m_ButtonDisconnect);
	DDX_Control(pDX, IDC_PLAY, m_ButtonPlay);
	DDX_Control(pDX, IDC_PAUSE, m_ButtonPause);
	DDX_Control(pDX, IDC_END, m_ButtonEnd);
	DDX_Control(pDX, IDC_BEGIN, m_ButtonBegin);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CArgusDlg, CDialog)
	//{{AFX_MSG_MAP(CArgusDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_ABOUT_INFO, OnAboutInfo)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_TIMER()
	ON_MESSAGE(WM_UPDATE_GUI,OnUpdateGUI)
	ON_MESSAGE(WM_GAME_RESTART,OnGameRestart)
	ON_COMMAND(ID_TOOLS_OPTIONS, OnToolsOptions)
	ON_COMMAND(ID_VIEW_DEBUG, OnViewDebug)
	ON_COMMAND(ID_VIEW_MAP, OnViewMap)
	ON_COMMAND(ID_VIEW_CONSOLE, OnViewConsole)
	ON_COMMAND(ID_VIEW_STATS, OnViewStats)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_BN_CLICKED(IDC_BEGIN, OnBeginButton)
	ON_COMMAND(ID_FILE_DISCONNECT, OnDisconnectButton)
	ON_BN_CLICKED(IDC_END, OnEndButton)
	ON_BN_CLICKED(IDC_PAUSE, OnPauseButton)
	ON_BN_CLICKED(IDC_PLAY, OnPlayButton)
	ON_COMMAND(ID_ABOUT_HELP, OnAboutHelp)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_SAVESTATSASHTML, OnFileSaveStats)
	ON_COMMAND(ID_ABOUT_HOMEPAGE, OnAboutHomepage)
	ON_NOTIFY(TCN_SELCHANGE, IDC_MAINDIALOGTAB, OnSelchangeMaindialogtab)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnectButton)
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArgusDlg message handlers

BOOL CArgusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CDialog m_Splash;
	m_Splash.Create(IDD_SPLASHSCREEN,this);
	m_Splash.ShowWindow(true);
	m_Splash.UpdateWindow();
		

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO wait mouse cursor einbauen

	// Grundeinstellungen laden
	OptionsDefault();

	// lade aktuelle einstellungen aus registry
	OptionsLoad();
	
	// das men laden
	m_Menu.LoadMenu(IDR_MENU);	// lade menu aus den resources
	SetMenu(&m_Menu);			// binde menu an diesen Dialog

	// position des Tab pos helpers ermittel und umsetzen
	CRect rect,size;
	m_TabPosHelper.GetWindowRect(&rect);	// hilft mir immer die richte stelle zu treffen
	ScreenToClient(&rect);

	m_TabPosHelper.GetClientRect(&size);
	
	// die ansicheten laden
	
	m_ViewConsole.Create(IDD_CONSOLE,this);
	m_ViewConsole.SetWindowPos(NULL,rect.left,rect.top,size.right,size.bottom,0);

	m_ViewMap.Create(IDD_MAP,this);
	m_ViewMap.SetWindowPos(NULL,rect.left,rect.top,size.right,size.bottom,0);

	m_ViewGraph.Create(IDD_GRAPH,this);
	m_ViewGraph.SetWindowPos(NULL,rect.left,rect.top,size.right,size.bottom,0);

	m_ViewStats.Create(IDD_STATS,this);
	m_ViewStats.SetWindowPos(NULL,rect.left,rect.top,size.right,size.bottom,0);

	m_ViewDebug.Create(IDD_DEBUG,this);
	m_ViewDebug.SetWindowPos(NULL,rect.left,rect.top,size.right,size.bottom,0);

	
	
	
	// die schaltflchen laden	
	m_ButtonBegin.SetIcon((HICON)LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_BEGIN),IMAGE_ICON,16,16,0));
	m_ButtonPlay.SetIcon((HICON)LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PLAY),IMAGE_ICON,16,16,0));
	m_ButtonPause.SetIcon((HICON)LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PAUSE),IMAGE_ICON,16,16,0));
	m_ButtonEnd.SetIcon((HICON)LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_END),IMAGE_ICON,16,16,0));
	m_ButtonDisconnect.SetIcon((HICON)LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_DISCONNECT),IMAGE_ICON,16,16,0));
	
	// schaltflchen deaktivieren
	m_ButtonBegin.EnableWindow(false);
	m_ButtonPlay.EnableWindow(false);
	m_ButtonPause.EnableWindow(false);
	m_ButtonEnd.EnableWindow(false);
	m_ButtonDisconnect.EnableWindow(false);
	m_ViewConsole.m_InputCtrl.EnableWindow(false);

	m_Menu.EnableMenuItem(ID_FILE_OPEN,MF_ENABLED);
	m_Menu.EnableMenuItem(ID_FILE_SAVE,MF_GRAYED);
	m_Menu.EnableMenuItem(ID_FILE_STARTCLIENT,MF_ENABLED);
	m_Menu.EnableMenuItem(ID_FILE_DISCONNECT,MF_GRAYED);

	// Registerkarte einstellen
	m_MainTab.InsertItem(VIEW_CONSOLE,"Console");
	m_MainTab.InsertItem(VIEW_MAP,"Level View");
	m_MainTab.InsertItem(VIEW_GRAPH,"Player Graphs");
	m_MainTab.InsertItem(VIEW_STATS,"Statistics");
	if (g_Debug) m_MainTab.InsertItem(VIEW_DEBUG,"Debug");
  	
		
	g_DataSourceLast = DS_NONE;
	g_DataSourceType = DS_NONE; 

	g_CallingDialogHandle = GetSafeHwnd();	 // globals handel fr alle verfgbar machen

	// win socks initialisieren
	WSADATA WSAData;
	if(WSAStartup(MAKEWORD(1,1), &WSAData)!= 0)
		MessageBox("Sockets could not be started.", "Error", MB_OK|MB_ICONERROR);

	// console starten
	ConsoleInit();	
	ConsolePrint("Initialized console...");
	ConsolePrint("Welcome to ARGUS, your personal Quake Spectator.");
	ConsolePrint("Copyright (c) 2000 by Martin Otten aka [UTG]LOKi");
	ConsolePrint("Visit my homepage http://argus.splatterworld.de");
	ConsolePrint("Send critics, greetings, money or job offers to loki@clan-utgard.de.");

	// spiel zurcksetzen
	GameInit(0,0);	

	// falls continuierliche refresh rate jetzt starten
	if (g_Options.RefreshRate)
		SetTimer(1, g_Options.RefreshRate, 0);

	// console als aktuelle sicht einstellen
	ClearView();
	OnViewConsole();

	// in der debug version splash screen nur kurz zeigen
	if (g_Debug)
		Sleep(250);
	else
	{
		Sleep(3000);
	};


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CArgusDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArgusDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArgusDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CArgusDlg::OnAboutInfo() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
}

void CArgusDlg::OnAboutHelp() 
{
	char FullHelpFileName[1024];
	char HelpFileDir[1024];

	sprintf(FullHelpFileName,"%s\\help\\index.html",g_ArgusPath);
	sprintf(HelpFileDir,"%s\\help",g_ArgusPath);

	ShellExecute(NULL,"open",FullHelpFileName,NULL,HelpFileDir,SW_SHOWNORMAL);
	
}

void CArgusDlg::OnAboutHomepage() 
{
	ShellExecute(NULL,"open","http://argus.splatterworld.de",NULL,NULL,SW_SHOWNORMAL);
}


void CArgusDlg::OnFileExit() 
{
	// speichere optionen
	if (g_DataSourceType!=DS_NONE)
	{
		if (g_DataSourceType==DS_DEMOFILE)
		{
			m_Demo.Stop();
			OptionsSave();
			OnOK();	
		}
		else
			MessageBox("Please diconnect from server before closing Argus.","Error",MB_OK);
	}
	else
	{
		OptionsSave();
		OnOK();	
	}
}

void CArgusDlg::OnClose() 
{
	OnFileExit();
}

LRESULT CArgusDlg::OnGameRestart(WPARAM wParam, LPARAM lParam)
{
	// pausiere bei demowiedergabe
	g_DataSourceSpeed=0;

	// gib wartemeldung aus
	SetDlgItemText(IDC_STATUSTEXT,"Loading level data. Please wait ...");
	Invalidate(false);

	m_ViewMap.RestartView();	// neue map bmp laden

	// lass demo weiterlaufe
	g_DataSourceSpeed=1;
	return 0;		
}

void CArgusDlg::OnTimer(UINT nIDEvent) 
{
	if (m_DataUpdated)
	{
		UpdateActualView();
		m_DataUpdated=false;
	}

	// lese weiter WM_TIMER messages, damit es nicht zu einem overflow kommt
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
	
	CDialog::OnTimer(nIDEvent);
}

void CArgusDlg::OnToolsOptions() // menuPunkt tools options gewhlt
{
	COptionsDlg OptionsDlg;
	OptionsDlg.DoModal();
	if (g_Options.RefreshRate)
		SetTimer(1, g_Options.RefreshRate, 0);
	else
		KillTimer(1);
	
}

void CArgusDlg::OnSelchangeMaindialogtab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ClearView();

	switch (m_MainTab.GetCurSel())
	{
		case VIEW_CONSOLE	: OnViewConsole();break;
		case VIEW_MAP		: OnViewMap()	;break;
		case VIEW_GRAPH		: OnViewGraph()	;break;
		case VIEW_DEBUG		: OnViewDebug()	;break;
		case VIEW_STATS		: OnViewStats()	;break;
		default: OnViewConsole();break;
	}

	*pResult = 0;
}


void CArgusDlg::OnViewDebug() // menuPunkt View debug gewhlt
{
	g_Options.DebugActive=true;	// debugging einschalten, kostet performance
	m_ViewDebug.ShowWindow(true);
	m_ActualView = VIEW_DEBUG;
	m_ViewDebug.UpdateView();
	
}

void CArgusDlg::OnViewMap() // menuPunkt View map gewhlt
{
	m_ViewMap.ShowWindow(true);
	m_ActualView = VIEW_MAP;
	g_cgs.PlayerInfoUpdate=true;	// TODO FIXME nicht sauber
	m_ViewMap.UpdateView();
}

void CArgusDlg::OnViewStats() 
{
	m_ViewStats.ShowWindow(true);
	m_ActualView = VIEW_STATS;
	m_ViewStats.UpdateView();
}


void CArgusDlg::OnViewConsole() // menuPunkt View console gewhlt
{
	m_ViewConsole.ShowWindow(true);
	m_ActualView = VIEW_CONSOLE;
	m_ViewConsole.UpdateView();
	// setze fokus
	m_ViewConsole.m_InputCtrl.SetFocus();
}

void CArgusDlg::OnViewGraph() 
{
	m_ViewGraph.ShowWindow(true);
	m_ActualView = VIEW_GRAPH;
	g_cgs.PlayerInfoUpdate=true; // TODO FIXME nicht sauber
	m_ViewGraph.UpdateView();
	
}

void CArgusDlg::ClearView()	// setzt alle view einstellungen zurck
{
	/*switch(m_ActualView)
	{
		case VIEW_DEBUG		:	m_Menu.CheckMenuItem(ID_VIEW_DEBUG,MF_UNCHECKED | MF_BYCOMMAND); 
								m_ViewDebug.ShowWindow(false);break;

		case VIEW_MAP		:	m_Menu.CheckMenuItem(ID_VIEW_MAP,MF_UNCHECKED | MF_BYCOMMAND); 
								m_ViewMap.ShowWindow(false);break;

		case VIEW_CONSOLE	:	m_Menu.CheckMenuItem(ID_VIEW_CONSOLE,MF_UNCHECKED | MF_BYCOMMAND); 
								m_ViewConsole.ShowWindow(false);break;

		case VIEW_STATS		:	m_ViewStats.ShowWindow(false);break;

		case VIEW_GRAPH		:	m_ViewGraph.ShowWindow(false);break;
	};*/

	m_ViewDebug.ShowWindow(false);
	m_ViewMap.ShowWindow(false);
	m_ViewConsole.ShowWindow(false);
	m_ViewStats.ShowWindow(false);
	m_ViewGraph.ShowWindow(false);
	
	m_ActualView=VIEW_NONE;
	g_Options.DebugActive=false;

}

void CArgusDlg::UpdateActualView()
{
	char statustext[255];
	// falls es keine datasource mehr gibt, disable disconnect button
	if (!g_DataSourceType)
	{
		// knpfe ausschalten
		m_ButtonDisconnect.EnableWindow(false);
		m_ViewConsole.m_InputCtrl.EnableWindow(false);

		if (g_DataSourceLast==DS_CLIENT)
		{
			m_Menu.EnableMenuItem(ID_FILE_OPEN,MF_ENABLED);
			m_Menu.EnableMenuItem(ID_FILE_SAVE,MF_ENABLED);
			m_Menu.EnableMenuItem(ID_FILE_STARTCLIENT,MF_ENABLED);
			m_Menu.EnableMenuItem(ID_FILE_DISCONNECT,MF_GRAYED);
			SetWindowText("Argus");
		};
	};		

	if (!g_DataSourceSpeed && (g_DataSourceType==DS_DEMOFILE))
	{	m_ButtonPlay.EnableWindow(true);
		m_ButtonPause.EnableWindow(false);
	}

	// in jeder sicht aktaulisiere status text; IDC_STATUSTEXT
	DWORD st = g_cgs.snap->serverTime / 1000;	// servertime in ms
	int min = st / 60;
	int sek =  st - min*60;
	
	switch(g_DataSourceSpeed)
	{
		case (-1):	sprintf(statustext,"%u:%.2u Fastest Play",min,sek);break;
		case (0):	sprintf(statustext,"%u:%.2u Paused",min,sek);break;
		case (1):	sprintf(statustext,"%u:%.2u Normal Play",min,sek);break;
		default:	sprintf(statustext,"%u:%.2u Fast Play (x%i)",min,sek,g_DataSourceSpeed);break;
	}
	
	SetDlgItemText(IDC_STATUSTEXT,statustext);


	switch(m_ActualView)
	{
		case VIEW_DEBUG		:	m_ViewDebug.UpdateView();break;

		case VIEW_MAP		:	m_ViewMap.UpdateView();break;

//		case VIEW_STATS		:	m_ViewStats.UpdateView();break;

		case VIEW_CONSOLE	:	m_ViewConsole.UpdateView();break;

		case VIEW_GRAPH		:	m_ViewGraph.UpdateView();break;
	};

}


void CArgusDlg::OnFileOpen() 
{
	OPENFILENAME ofn;

	char filebuffer[1024];
	char dummy[1024];

	memset(filebuffer,0,sizeof(filebuffer));
	memset(&ofn,0,sizeof(ofn));

	ofn.lStructSize=sizeof(ofn); 
	ofn.lpstrFilter="Quake 3 Demo\0*.DM3\0";

	ofn.lpstrFile=filebuffer;
	ofn.nMaxFile=sizeof(filebuffer);	// path und filename

	sprintf(dummy,"%s\\demos",g_ArgusPath);
	ofn.lpstrInitialDir=dummy;
	
	ofn.lpstrTitle = "Select Quake 3 Demo File";
	ofn.Flags= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_SHAREAWARE ;
	
 	if (GetOpenFileName(&ofn))
	{
		// falls noch ein demo luft erst diesen thread beenden
		m_Demo.Stop();

		m_Demo.Init();
		m_Demo.SetFile(filebuffer);
		m_Demo.Start();
		
		sprintf(dummy,"Argus - %s ",filebuffer);
		SetWindowText(dummy);

		m_ButtonBegin.EnableWindow(true);
		m_ButtonPlay.EnableWindow(true);
		m_ButtonPause.EnableWindow(true);
		m_ButtonEnd.EnableWindow(true);
		m_ButtonDisconnect.EnableWindow(true);

		m_Menu.EnableMenuItem(ID_FILE_OPEN,MF_ENABLED);
		m_Menu.EnableMenuItem(ID_FILE_SAVE,MF_GRAYED);
		m_Menu.EnableMenuItem(ID_FILE_STARTCLIENT,MF_ENABLED);
		m_Menu.EnableMenuItem(ID_FILE_DISCONNECT,MF_GRAYED);

	}
	
}


void CArgusDlg::OnFileSaveStats() 
{
	m_ViewStats.SaveAsHTML();
}



LRESULT CArgusDlg::OnUpdateGUI(WPARAM wParam, LPARAM lParam)
{
	if (g_Options.RefreshRate==0)
		UpdateActualView();		// bei 0 wird bei jeder message gezeichnet
	else
		m_DataUpdated=true;		// informiere so den timer 

	// lsche alle messages dieses Types, die bis jetzt noch in der warteschlange stehen
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_UPDATE_GUI, WM_UPDATE_GUI, PM_REMOVE));
	return 0;
}

void CArgusDlg::OnBeginButton() 
{
	// falls noch ein demo luft erst diesen thread beenden
	m_Demo.Stop();

	m_Demo.Start();
}

void CArgusDlg::OnDisconnectButton() 
{
	g_DataSourceType=DS_NONE;
}

void CArgusDlg::OnEndButton() 
{
	g_DataSourceSpeed=-1;
}

void CArgusDlg::OnPauseButton() 
{
	g_DataSourceSpeed=0;
	m_ButtonPlay.EnableWindow(true);
	m_ButtonPause.EnableWindow(false);
}

void CArgusDlg::OnPlayButton() 
{
	g_DataSourceSpeed+=1;	// pause aufheben
	m_ButtonPause.EnableWindow(true);
}

