// ArgusDlg.h : header file
//

#if !defined(AFX_ARGUSDLG_H__0893EACE_7CE8_49EC_BB3F_A9E95A099964__INCLUDED_)
#define AFX_ARGUSDLG_H__0893EACE_7CE8_49EC_BB3F_A9E95A099964__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CArgusDlg dialog

#include "ViewDebug.h"
#include "ViewMap.h"
#include "ViewConsole.h"
#include "ViewGraph.h"
#include "ViewStats.h"
#include "Demo.h"

class CArgusDlg : public CDialog
{
// Construction
public:
	
	void UpdateActualView();
	void ClearView();
	// void OnPacketFromServer();
	CArgusDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CArgusDlg)
	enum { IDD = IDD_ARGUS_DIALOG };
	CStatic	m_TabPosHelper;
	CTabCtrl	m_MainTab;
	CButton	m_ButtonDisconnect;
	CButton	m_ButtonPlay;
	CButton	m_ButtonPause;
	CButton	m_ButtonEnd;
	CButton	m_ButtonBegin;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CArgusDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON			m_hIcon;
	CMenu			m_Menu;		// die menleiste
	CToolBarCtrl	m_ToolBar;	// die button leiste

	CDemo			m_Demo;		// das demo aus dem die aktuellen daten kommen

	CViewDebug		m_ViewDebug;	// die debug ansicht
	CViewMap		m_ViewMap;		// die karten ansicht
	CViewConsole	m_ViewConsole;	// die Konsole
	CViewStats		m_ViewStats;	// HTML statistiken
	CViewGraph		m_ViewGraph;	// spielerdaten als graphen
	BYTE			m_ActualView;	// Zeiger auf die aktuelle Ansicht
	bool			m_DataUpdated;	// falls sich irgendwelche spielwerte verndert habe = true


	// Generated message map functions
	//{{AFX_MSG(CArgusDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAboutInfo();
	afx_msg void OnFileExit();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg LRESULT OnUpdateGUI(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnGameRestart(WPARAM wParam, LPARAM lParam);
	afx_msg void OnToolsOptions();
	afx_msg void OnViewDebug();
	afx_msg void OnViewMap();
	afx_msg void OnViewConsole();
	afx_msg void OnViewStats();
	afx_msg void OnFileOpen();
	afx_msg void OnViewGraph();
	afx_msg void OnBeginButton();
	afx_msg void OnDisconnectButton();
	afx_msg void OnEndButton();
	afx_msg void OnPauseButton();
	afx_msg void OnPlayButton();
	afx_msg void OnAboutHelp();
	afx_msg void OnClose();
	afx_msg void OnFileSaveStats();
	afx_msg void OnAboutHomepage();
	afx_msg void OnSelchangeMaindialogtab(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARGUSDLG_H__0893EACE_7CE8_49EC_BB3F_A9E95A099964__INCLUDED_)
