// CGame.cpp

#include "cgame.h"
#include "packet.h"
#include "console.h"
#include "options.h"
#include "threads.h"
#include "demo.h"
#include "statistics.h"
#include "math.h"
#include "common.h"

cgs_t			g_cgs;		// DAS globale Game objekt,das alle informationen hlt
cg_t			g_cg;		// verwaltet die snapshots
centity_t		g_cg_entities[MAX_GENTITIES];			// die entities des Clients

entityState_t	g_baseline[MAX_BASLINE_ENTITIES];	// alle statischen Entities der Map werden einmal am anfang mit dem Gamestate hier eingetragen
entityState_t	g_ringbuff[MAX_RINGBUF_ENTITIES];	// hier werde die Entities aus den snapshots der reihe nach gespeicher
snapshot_t		g_snapshotbuffer[MAX_SNAPSHOTS_BUFFERED];	// die letzten snapshots fr die delta comprssion

int			g_ringbuff_pos=0;	// aktuelle Position im Ringbuffer

// weaponInfo_t		cg_weapons[MAX_WEAPONS];
// itemInfo_t			cg_items[MAX_ITEMS];


/*QUAKED item_***** ( 0 0 0 ) (-16 -16 -16) (16 16 16) suspended
DO NOT USE THIS CLASS, IT JUST HOLDS GENERAL INFORMATION.
The suspended flag will allow items to hang in the air, otherwise they are dropped to the next surface.

If an item is the target of another entity, it will not spawn in until fired.

An item fires all of its targets when it is picked up.  If the toucher can't carry it, the targets won't be fired.

"notfree" if set to 1, don't spawn in free for all games
"notteam" if set to 1, don't spawn in team games
"notsingle" if set to 1, don't spawn in single player games
"wait"	override the default wait before respawning.  -1 = never respawn automatically, which can be used with targeted spawning.
"random" random number of plus or minus seconds varied from the respawn time
"count" override quantity or duration on most items.
*/

gitem_t	bg_itemlist[] = 
{
//  { classname					Iconh	PickupName			Val	Type		TargetItem
	{ NULL,						NULL,	NULL,				0,	0,			0},
	{ "item_armor_shard",		NULL,	"Armor Shard",		5,	IT_ARMOR,	0},
	{ "item_armor_combat",		NULL,	"Armor",			50,	IT_ARMOR,	0},
	{ "item_armor_body",		NULL,	"Heavy Armor",		100,IT_ARMOR,	0},
	{ "item_health_small",		NULL,	"5 Health",			5,	IT_HEALTH,	0},
	{ "item_health",			NULL,	"25 Health",		25,	IT_HEALTH,	0},
	{ "item_health_large",		NULL,	"50 Health",		50,	IT_HEALTH,	0},
	{ "item_health_mega",		NULL,	"Mega Health",		100,IT_HEALTH,	0},
	// WEAPONS 
	{ "weapon_gauntlet",		NULL,	"Gauntlet",			0,	IT_WEAPON,	WP_GAUNTLET},
	{ "weapon_shotgun",			NULL,	"Shotgun",			10,	IT_WEAPON,	WP_SHOTGUN},
	{ "weapon_machinegun",		NULL, 	"Machinegun",		40,	IT_WEAPON,	WP_MACHINEGUN},
	{ "weapon_grenadelauncher",	NULL,	"Grenade Launcher",	10,	IT_WEAPON,	WP_GRENADE_LAUNCHER},
	{ "weapon_rocketlauncher",	NULL,	"Rocket Launcher",	10,	IT_WEAPON,	WP_ROCKET_LAUNCHER},
	{ "weapon_lightning",		NULL,	"Lightning Gun",	100,IT_WEAPON,	WP_LIGHTNING},
	{ "weapon_railgun",			NULL,	"Railgun",			10,	IT_WEAPON,	WP_RAILGUN},
	{ "weapon_plasmagun",		NULL,	"Plasma Gun",		50,	IT_WEAPON,	WP_PLASMAGUN},
	{ "weapon_bfg",				NULL,	"BFG10K",			20,	IT_WEAPON,	WP_BFG},
	{ "weapon_grapplinghook",	NULL,	"Grappling Hook",	0,	IT_WEAPON,	WP_GRAPPLING_HOOK},
	// AMMO ITEMS
	{ "ammo_shells",			NULL,	"Shells",			10,	IT_AMMO,	WP_SHOTGUN},
	{ "ammo_bullets",			NULL,	"Bullets",			50,	IT_AMMO,	WP_MACHINEGUN},
	{ "ammo_grenades",			NULL,	"Grenades",			5,	IT_AMMO,	WP_GRENADE_LAUNCHER},
	{ "ammo_cells",				NULL,	"Cells",			30,	IT_AMMO,	WP_PLASMAGUN},
	{ "ammo_lightning",			NULL,	"Lightning",		60,	IT_AMMO,	WP_LIGHTNING},
	{ "ammo_rockets",			NULL,	"Rockets",			5,	IT_AMMO,	WP_ROCKET_LAUNCHER},
	{ "ammo_slugs",				NULL,	"Slugs",			10,	IT_AMMO,	WP_RAILGUN},
	{ "ammo_bfg",				NULL,	"Bfg Ammo",			15,	IT_AMMO,	WP_BFG,},
	// HOLDABLE ITEMS
	{ "holdable_teleporter",	NULL,	"Personal Teleporter", 60, IT_HOLDABLE, HI_TELEPORTER},
	{ "holdable_medkit",		NULL,	"Medkit",			60,	IT_HOLDABLE,HI_MEDKIT},
	// POWERUP ITEMS
	{ "item_quad",				NULL,	"Quad Damage",		30,	IT_POWERUP,	PW_QUAD},
	{ "item_enviro",			NULL,	"Battle Suit",		30,	IT_POWERUP,	PW_BATTLESUIT},
	{ "item_haste",				NULL,	"Speed",			30,	IT_POWERUP,	PW_HASTE},
	{ "item_invis",				NULL,	"Invisibility",		30,	IT_POWERUP,	PW_INVIS},
	{ "item_regen",				NULL,	"Regeneration",		30,	IT_POWERUP,	PW_REGEN},
	{ "item_flight",			NULL,	"Flight",			60,	IT_POWERUP,	PW_FLIGHT},
	//Only in CTF games
	{ "team_CTF_redflag",		NULL,	"Red Flag",			0,	IT_TEAM,	PW_REDFLAG},
	{ "team_CTF_blueflag",		NULL,	"Blue Flag",		0,	IT_TEAM,	PW_BLUEFLAG},

	// end of list marker
	{NULL}
};

int		bg_numItems = sizeof(bg_itemlist) / sizeof(bg_itemlist[0]) - 1;

BYTE KnownBitMasks[32][7]=		// hufig gebraucht Bitmasken
	{
		{0x60,0x80,0x00,0x00,0x00,0x00,0x00},
		{0x60,0x00,0x00,0x00,0x00,0x00,0x00},
		{0x60,0xC0,0x00,0x00,0x00,0x00,0x00},
		{0xE1,0x00,0x00,0x00,0x00,0x20,0x00},
		{0x60,0x80,0x00,0x00,0x00,0x10,0x00},
		{0xE0,0x80,0x00,0x00,0x00,0x00,0x00},
		{0xE0,0xC0,0x00,0x00,0x00,0x00,0x00},
		{0x00,0x00,0x00,0x00,0x00,0x10,0x00},
		{0x40,0x80,0x00,0x00,0x00,0x00,0x00},
		{0x20,0x80,0x00,0x00,0x00,0x00,0x00},
		{0x60,0x80,0x00,0x00,0x01,0x00,0x00},
		{0xED,0x07,0x00,0x00,0x00,0x80,0x00},
		{0xE0,0x00,0x00,0x00,0x00,0x00,0x00},
		{0xED,0x07,0x00,0x00,0x00,0x30,0x00},
		{0x80,0x00,0x00,0x00,0x00,0x00,0x00},
		{0x40,0x00,0x00,0x00,0x00,0x00,0x00},
		{0xE0,0xC0,0x00,0x00,0x00,0x10,0x00},
		{0x60,0x00,0x00,0x00,0x00,0x10,0x00},
		{0x20,0x00,0x00,0x00,0x00,0x00,0x00},
		{0xE1,0x00,0x00,0x00,0x04,0x20,0x00},
		{0xE1,0x00,0xC0,0x01,0x20,0x20,0x00},
		{0xE0,0xC0,0x00,0x00,0x01,0x00,0x00},
		{0x60,0x40,0x00,0x00,0x00,0x00,0x00},
		{0x40,0xC0,0x00,0x00,0x00,0x00,0x00},
		{0x60,0xC0,0x00,0x00,0x01,0x00,0x00},
		{0x60,0xC0,0x00,0x00,0x00,0x10,0x00},
		{0x60,0x80,0x00,0x00,0x01,0x00,0x01},
		{0x60,0x80,0x00,0x00,0x00,0x30,0x00},
		{0xE0,0x80,0x00,0x00,0x00,0x10,0x00},
		{0x20,0xC0,0x00,0x00,0x00,0x00,0x00},
		{0x60,0x80,0x00,0x00,0x00,0x00,0x02},
		{0xE0,0x40,0x00,0x00,0x00,0x00,0x00}
	}; 



// orginal ID funktion
void CG_Obituary( entityState_t *ent )
{
	int				mod;				// wie
	int				target, attacker;	// wer von wem
	char			*message;
	char			*message2;
	char			dummy[255];
	clientInfo_t	*targetinfo = NULL;	// das target ist immer ein client
	clientInfo_t	*attackerinfo = NULL;	// muss kein client sein, kann auch world sein


	target = ent->otherEntityNum;
	attacker = ent->otherEntityNum2;
	mod = ent->eventParm;



	if ( target < 0 || target >= MAX_CLIENTS )	// das target muss ein Client sein
		ConsolePrint("CG_Obituary: target out of range");
	
	targetinfo = &g_cgs.clientinfo[target];

	if ( attacker < 0 || attacker >= MAX_CLIENTS )	// ist der attacker kein client ??
		// attacker = ENTITYNUM_WORLD;	// orginal, gndert damit selbstmorde besser erkannt werden
		attacker=target;
	else 
		attackerinfo = &g_cgs.clientinfo[attacker];
		
	message2 = "";

	if (mod>=MAX_MEANS_OF_DEATH)
	{
		ConsolePrint("Unknown Kind Of Death!");
		return;
	}

	g_statistics.kills[attacker][target][mod]++;	// kill statistic angleichen

	if (attacker == target)	// selbstmord oder "unfall"
	{
		switch (mod) 
		{
			case MOD_GRENADE_SPLASH:message = "tripped on own grenade.";	break;
			case MOD_ROCKET_SPLASH:	message = "blew up by own rocket.";break;
			case MOD_PLASMA_SPLASH:	message = "melted by own plasma.";	break;
			case MOD_BFG_SPLASH:	message = "should have used a smaller gun.";	break;
			case MOD_SUICIDE:		message = "suicides";break;
			case MOD_FALLING:		message = "cratered";break;
			case MOD_CRUSH:			message = "was squished";break;
			case MOD_WATER:			message = "sank like a rock";break;
			case MOD_SLIME:			message = "melted";	break;
			case MOD_LAVA:			message = "does a back flip into the lava";	break;
			case MOD_TARGET_LASER:	message = "saw the light";break;
			case MOD_TRIGGER_HURT:	message = "was in the wrong place";	break;
			default:				message = "committed suicid."; break;
		}
		sprintf(dummy,"%s %s.", targetinfo->name, message);
		ConsolePrint(dummy);
		return;
	}
	else
	{
		switch (mod) 
		{
			case MOD_GRAPPLE:	message = "was caught by";	break;
			case MOD_GAUNTLET:		message = "was pummeled by";break;
			case MOD_MACHINEGUN:	message = "was machinegunned by";break;
			case MOD_SHOTGUN:		message = "was gunned down by";	break;
			case MOD_GRENADE:		message = "ate";message2 = "'s grenade";break;
			case MOD_GRENADE_SPLASH:message = "was shredded by";message2 = "'s shrapnel";break;
			case MOD_ROCKET:		message = "ate";message2 = "'s rocket";break;
			case MOD_ROCKET_SPLASH:	message = "almost dodged";message2 = "'s rocket";break;
			case MOD_PLASMA:		message = "was melted by";message2 = "'s plasmagun";break;
			case MOD_PLASMA_SPLASH:	message = "was melted by";message2 = "'s plasmagun";break;
			case MOD_RAILGUN:		message = "was railed by";break;
			case MOD_LIGHTNING:		message = "was electrocuted by";break;
			case MOD_BFG:
			case MOD_BFG_SPLASH:	message = "was blasted by";message2 = "'s BFG";	break;
			case MOD_TELEFRAG:		message = "tried to invade";message2 = "'s personal space";	break;
			default:				message = "was killed by";break;
		}
		sprintf(dummy, "%s %s %s%s.", targetinfo->name, message, attackerinfo->name, message2);
		ConsolePrint(dummy);
		return;
	}

	// we don't know what it was
	sprintf(dummy,"%s died.", targetinfo->name );
	ConsolePrint(dummy);

}

// orginal ID funktion
// void CG_EntityEvent( centity_t *cent, vec3_t position ) {
void CG_EntityEvent(entityState_t * es)
{
	int				event;
	int				clientNum;
	clientInfo_t	*ci;
	char			eventtext[255];
	char			dummy[255];
	
	event = es->event & ~EV_EVENT_BITS;

	if ( !event ) {
		ConsolePrint("ZEROEVENT");
		return;
	}

	clientNum = es->clientNum;
	if ( clientNum < 0 || clientNum >= MAX_CLIENTS ) {
		clientNum = 0;
	}
	ci = &g_cgs.clientinfo[ clientNum ];

	switch ( event ) {
	/*case EV_FOOTSTEP:		strcpy(eventtext,"EV_FOOTSTEP");	break;
	case EV_FOOTSTEP_METAL:	strcpy(eventtext,"EV_FOOTSTEP_METAL");break;
	case EV_FOOTSPLASH:		strcpy(eventtext,"EV_FOOTSPLASH");break;
	case EV_FOOTWADE:		strcpy(eventtext,"EV_FOOTWADE");break;
	case EV_SWIM:			strcpy(eventtext,"EV_SWIM");break;
	case EV_FALL_SHORT:		strcpy(eventtext,"EV_FALL_SHORT");break;
	case EV_FALL_MEDIUM:	strcpy(eventtext,"EV_FALL_MEDIUM");	break;
	case EV_FALL_FAR:		strcpy(eventtext,"EV_FALL_FAR");break;
	case EV_STEP_4:
	case EV_STEP_8:
	case EV_STEP_12:
	case EV_STEP_16:		strcpy(eventtext,"EV_STEP");break;
	case EV_JUMP_PAD:		strcpy(eventtext,"EV_JUMP_PAD");break;
	case EV_JUMP:			strcpy(eventtext,"EV_JUMP");break;
	case EV_TAUNT:			strcpy(eventtext,"EV_TAUNT");break;
	case EV_WATER_TOUCH:	strcpy(eventtext,"EV_WATER_TOUCH");	break;
	case EV_WATER_LEAVE:	strcpy(eventtext,"EV_WATER_LEAVE");	break;
	case EV_WATER_UNDER:	strcpy(eventtext,"EV_WATER_UNDER");	break;
	case EV_WATER_CLEAR:	strcpy(eventtext,"EV_WATER_CLEAR");	break;
	case EV_ITEM_PICKUP:	strcpy(eventtext,"EV_ITEM_PICKUP");	break;
	case EV_GLOBAL_ITEM_PICKUP:	strcpy(eventtext,"EV_GLOBAL_ITEM_PICKUP");	break;
	case EV_NOAMMO:			strcpy(eventtext,"EV_NOAMMO"); break;
	case EV_CHANGE_WEAPON:	strcpy(eventtext,"EV_CHANGE_WEAPON");break;
	case EV_FIRE_WEAPON:	strcpy(eventtext,"EV_FIRE_WEAPON");	break;
	case EV_USE_ITEM0:		strcpy(eventtext,"EV_USE_ITEM0");break;
	case EV_USE_ITEM1:		strcpy(eventtext,"EV_USE_ITEM1");break;
	case EV_USE_ITEM2:		strcpy(eventtext,"EV_USE_ITEM2");break;
	case EV_USE_ITEM3:		strcpy(eventtext,"EV_USE_ITEM3");break;
	case EV_USE_ITEM4:		strcpy(eventtext,"EV_USE_ITEM4");break;
	case EV_USE_ITEM5:		strcpy(eventtext,"EV_USE_ITEM5");break;
	case EV_USE_ITEM6:		strcpy(eventtext,"EV_USE_ITEM6");break;
	case EV_USE_ITEM7:		strcpy(eventtext,"EV_USE_ITEM7");break;
	case EV_USE_ITEM8:		strcpy(eventtext,"EV_USE_ITEM8");break;
	case EV_USE_ITEM9:		strcpy(eventtext,"EV_USE_ITEM9");break;
	case EV_USE_ITEM10:		strcpy(eventtext,"EV_USE_ITEM10");break;
	case EV_USE_ITEM11:		strcpy(eventtext,"EV_USE_ITEM11");break;
	case EV_USE_ITEM12:		strcpy(eventtext,"EV_USE_ITEM12");break;
	case EV_USE_ITEM13:		strcpy(eventtext,"EV_USE_ITEM13");break;
	case EV_USE_ITEM14:		strcpy(eventtext,"EV_USE_ITEM14");break;
	case EV_PLAYER_TELEPORT_IN:		strcpy(eventtext,"EV_PLAYER_TELEPORT_IN");	break;
	case EV_PLAYER_TELEPORT_OUT:	strcpy(eventtext,"EV_PLAYER_TELEPORT_OUT");	break;
	case EV_ITEM_POP:		strcpy(eventtext,"EV_ITEM_POP");break;
	case EV_ITEM_RESPAWN:	strcpy(eventtext,"EV_ITEM_RESPAWN");break;
	case EV_GRENADE_BOUNCE:	strcpy(eventtext,"EV_GRENADE_BOUNCE");break;
	case EV_MISSILE_HIT:	strcpy(eventtext,"EV_MISSILE_HIT");break;
	case EV_MISSILE_MISS:	strcpy(eventtext,"EV_MISSILE_MISS");break;
	case EV_RAILTRAIL:		strcpy(eventtext,"EV_RAILTRAIL");break;
	case EV_BULLET_HIT_WALL:strcpy(eventtext,"EV_BULLET_HIT_WALL");break;
	case EV_BULLET_HIT_FLESH:strcpy(eventtext,"EV_BULLET_HIT_FLESH");break;
	case EV_SHOTGUN:		strcpy(eventtext,"EV_SHOTGUN");break;
	case EV_GENERAL_SOUND:	strcpy(eventtext,"EV_GENERAL_SOUND");break;
	case EV_GLOBAL_SOUND:	strcpy(eventtext,"EV_GLOBAL_SOUND");break;
	case EV_PAIN:			strcpy(eventtext,"EV_PAIN");break; 
	case EV_DEATH1:
	case EV_DEATH2: 
	case EV_DEATH3:			strcpy(eventtext,"EV_DEATHx");break; */
	case EV_OBITUARY:		strcpy(eventtext,"EV_OBITUARY");
							CG_Obituary( es );

							break; /*
	case EV_POWERUP_QUAD:	strcpy(eventtext,"EV_POWERUP_QUAD");break;
	case EV_POWERUP_BATTLESUIT:	strcpy(eventtext,"EV_POWERUP_BATTLESUIT");	break;
	case EV_POWERUP_REGEN:	strcpy(eventtext,"EV_POWERUP_REGEN");break;
	case EV_GIB_PLAYER:		strcpy(eventtext,"EV_GIB_PLAYER");break;
	case EV_DEBUG_LINE:		strcpy(eventtext,"EV_DEBUG_LINE");break; */

	default:strcpy(eventtext,"UNKNOWN event");break;
	}

	// sprintf(dummy,"ent:%3i  event:%3i %s", es->number, event,eventtext);
	// ConsolePrint(dummy);

}

void CG_CheckEvents( centity_t *cent )
{
	entityState_t * es = &g_ringbuff[cent->currentState & 0x7FF];

	// check for event-only entities

	if ( es->eType > ET_EVENTS ) {
		if ( cent->previousEvent ) {
			return;	// already fired
		}
		cent->previousEvent = 1;

		es->event = es->eType - ET_EVENTS;
	} else {
		// check for events riding with another entity
		if ( es->event == cent->previousEvent )
		{
			return;
		}
		cent->previousEvent = es->event;
		if ( ( es->event & ~EV_EVENT_BITS ) == 0 ) {
			return;
		}
	}

	// calculate the position at exactly the frame time

	CG_EntityEvent(es);
};


void ParseEntity(CPacket * p,int EntityIndex, entityState_t  * e,entityState_t  * olde)
{
	BYTE EntityBitMask[7]; // 56 Bits, 50 werden nur gebraucht
	DWORD MaskIndex;
	CString Text="";
	CString dummy;

	// entityState_t * e = &cent->currentState;	// hole aktuellen state des entities

	bool debug = g_Options.DebugActive && g_Options.DebugShowEntities;	// so gehts schneller

	if ((EntityIndex<0) || (EntityIndex>=MAX_GENTITIES))
		ConsolePrint("Bad Delta entity number !");
		

	if(p->ReadBit())	
	{
		if (debug) g_DebugText+=" Remove entity.\x0D\x0A";
		memset(e,0,sizeof(entityState_t));	// lsche das entity	
		// extra mssen noch die cg_entity eintrge gelscht werden

		// hier valid = 0, wenn der letzt snapshot vom gleichen client war
		if (g_cgs.lastSnap->ps.clientNum==g_cgs.snap->ps.clientNum)
			g_cg_entities[EntityIndex].currentValid = 0;
		else
			g_cg_entities[EntityIndex].currentValid = g_cgs.clientnum;

		e->number=ENTITYNUM_NONE;
	}
	else	
	{	
		if(p->ReadBit())
		{
			memcpy(e,olde,sizeof(entityState_t));	// von mir
						
			MaskIndex=p->ReadnBits(5);	// lies BitMasken Index
			if (MaskIndex==0x1F)		// keine bekannte bitmasken combination ?
			{
				//lies unbekannte 50 bit maske 
				for (MaskIndex=0;MaskIndex<6;MaskIndex++)
					EntityBitMask[MaskIndex]=p->ReadnBits(8);
				
				EntityBitMask[6]=p->ReadnBits(2) & 0x03;	// letzte 2 bit auch noch lesen
				if (debug) g_DebugText+=" <uc> ";	// unknown combination
			}
			else
			{
				// kopiere fertige bitmaske aus array
				memcpy(&EntityBitMask[0],&KnownBitMasks[MaskIndex][0],7+sizeof(BYTE));

				if (debug) { dummy.Format(" <%2i>",MaskIndex);Text+=dummy;}// Bitmask Index Number
			}

			if (EntityBitMask[0] & 1)	e->eType=p->ReadnBits(8);
			if (EntityBitMask[0] & 2)	e->eFlags=p->ReadnBits(16);
			if (EntityBitMask[0] & 4)	e->pos.trType=p->ReadnBits(8);
			if (EntityBitMask[0] & 8)	e->pos.trTime=p->ReadnBits(32);
			if (EntityBitMask[0] & 16)	e->pos.trDuration=p->ReadnBits(32);
			if (EntityBitMask[0] & 32)	e->pos.trBase[0]=p->ReadPackedFloat();
			if (EntityBitMask[0] & 64)	e->pos.trBase[1]=p->ReadPackedFloat();
			if (EntityBitMask[0] & 128)	e->pos.trBase[2]=p->ReadPackedFloat();
			if (EntityBitMask[1] & 1)	e->pos.trDelta[0]=p->ReadPackedFloat();
			if (EntityBitMask[1] & 2)	e->pos.trDelta[1]=p->ReadPackedFloat();
			if (EntityBitMask[1] & 4)	e->pos.trDelta[2]=p->ReadPackedFloat();
			if (EntityBitMask[1] & 8)	e->apos.trType=p->ReadnBits(8);
			if (EntityBitMask[1] & 16)	e->apos.trTime=p->ReadnBits(32);
			if (EntityBitMask[1] & 32)	e->apos.trDuration=p->ReadnBits(32);
			if (EntityBitMask[1] & 64)	e->apos.trBase[0]=p->ReadPackedFloat();
			if (EntityBitMask[1] & 128)	e->apos.trBase[1]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 1)	e->apos.trBase[2]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 2)	e->apos.trDelta[0]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 4)	e->apos.trDelta[1]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 8)	e->apos.trDelta[2]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 16)	e->time=p->ReadnBits(32);
			if (EntityBitMask[2] & 32)	e->time2=p->ReadnBits(32);
			if (EntityBitMask[2] & 64)	e->origin[0]=p->ReadPackedFloat();
			if (EntityBitMask[2] & 128)	e->origin[1]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 1)	e->origin[2]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 2)	e->origin2[0]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 4)	e->origin2[1]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 8)	e->origin2[2]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 16)	e->angles[0]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 32)	e->angles[1]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 64)	e->angles[2]=p->ReadPackedFloat();
			if (EntityBitMask[3] & 128)	e->angles2[0]=p->ReadPackedFloat();
			if (EntityBitMask[4] & 1)	e->angles2[1]=p->ReadPackedFloat();
			if (EntityBitMask[4] & 2)	e->angles2[2]=p->ReadPackedFloat();
			if (EntityBitMask[4] & 4)	e->otherEntityNum=p->ReadnBits(10);
			if (EntityBitMask[4] & 8)	e->otherEntityNum2=p->ReadnBits(10);
			if (EntityBitMask[4] & 16)	e->groundEntityNum=p->ReadnBits(10);
			if (EntityBitMask[4] & 32)	e->loopSound=p->ReadnBits(8);
			if (EntityBitMask[4] & 64)	e->constantLight=p->ReadnBits(32);
			if (EntityBitMask[4] & 128)	e->modelindex=p->ReadnBits(8);
			if (EntityBitMask[5] & 1)	e->modelindex2=p->ReadnBits(8);
			if (EntityBitMask[5] & 2)	e->frame=p->ReadnBits(16);
			if (EntityBitMask[5] & 4)	e->clientNum=p->ReadnBits(8);
			if (EntityBitMask[5] & 8)	e->solid=p->ReadnBits(24);
			if (EntityBitMask[5] & 16)	e->event=p->ReadnBits(10);
			if (EntityBitMask[5] & 32)	e->eventParm=p->ReadnBits(8);
			if (EntityBitMask[5] & 64)	e->powerups=p->ReadnBits(16);
			if (EntityBitMask[5] & 128)	e->weapon=p->ReadnBits(8);
			if (EntityBitMask[6] & 1)	e->legsAnim=p->ReadnBits(8);
			if (EntityBitMask[6] & 2)	e->torsoAnim=p->ReadnBits(8);
			
			e->number=EntityIndex;

			/*
			if (debug) 
			{
				if (EntityBitMask[0] & 1)	{dummy.Format("eType:%u ",e->eType);Text+=dummy;};
				if (EntityBitMask[0] & 2)	{dummy.Format("eFlags:%u ",e->eFlags);Text+=dummy;};
				if (EntityBitMask[0] & 4)	{dummy.Format("trType:%u ",e->pos.trType);Text+=dummy;};
				if (EntityBitMask[0] & 8)	{dummy.Format("trTime:%u ",e->pos.trTime);Text+=dummy;};
				if (EntityBitMask[0] & 16)	{dummy.Format("trDuration:%u ",e->pos.trDuration);Text+=dummy;};
				if (EntityBitMask[0] & 32)	{dummy.Format("trBase[0]:%f ",e->pos.trBase[0]);Text+=dummy;};
				if (EntityBitMask[0] & 64)	{dummy.Format("trBase[1]:%f ",e->pos.trBase[1]);Text+=dummy;};
				if (EntityBitMask[0] & 128)	{dummy.Format("trBase[2]:%f ",e->pos.trBase[2]);Text+=dummy;};
				if (EntityBitMask[1] & 1)	{dummy.Format("trDelta[0]:%f ",e->pos.trDelta[0]);Text+=dummy;};
				if (EntityBitMask[1] & 2)	{dummy.Format("trDelta[1]:%f ",e->pos.trDelta[1]);Text+=dummy;};
				if (EntityBitMask[1] & 4)	{dummy.Format("trDelta[2]:%f ",e->pos.trDelta[2]);Text+=dummy;};
				if (EntityBitMask[1] & 8)	{dummy.Format("apos.trType:%u ",e->apos.trType);Text+=dummy;};
				if (EntityBitMask[1] & 16)	{dummy.Format("apos.trTime:%u ",e->apos.trTime);Text+=dummy;};
				if (EntityBitMask[1] & 32)	{dummy.Format("apos.trDuration:%u ",e->apos.trDuration);Text+=dummy;};
				if (EntityBitMask[1] & 64)	{dummy.Format("apos.trBase[0]:%f ",e->apos.trBase[0]);Text+=dummy;};
				if (EntityBitMask[1] & 128)	{dummy.Format("apos.trBase[1]:%f ",e->apos.trBase[1]);Text+=dummy;};
				if (EntityBitMask[2] & 1)	{dummy.Format("apos.trBase[2]:%f ",e->apos.trBase[2]);Text+=dummy;};
				if (EntityBitMask[2] & 2)	{dummy.Format("apos.trDelta[0]:%f ",e->apos.trDelta[0]);Text+=dummy;};
				if (EntityBitMask[2] & 4)	{dummy.Format("apos.trDelta[1]:%f ",e->apos.trDelta[1]);Text+=dummy;};
				if (EntityBitMask[2] & 8)	{dummy.Format("apos.trDelta[2]:%f ",e->apos.trDelta[2]);Text+=dummy;};
				if (EntityBitMask[2] & 16)	{dummy.Format("time:%u ",e->time);Text+=dummy;};
				if (EntityBitMask[2] & 32)	{dummy.Format("time2:%u ",e->time2);Text+=dummy;};
				if (EntityBitMask[2] & 64)	{dummy.Format("origin[0]:%f ",e->origin[0]);Text+=dummy;};
				if (EntityBitMask[2] & 128)	{dummy.Format("origin[1]:%f ",e->origin[1]);Text+=dummy;};
				if (EntityBitMask[3] & 1)	{dummy.Format("origin[2]:%f ",e->origin[2]);Text+=dummy;};
				if (EntityBitMask[3] & 2)	{dummy.Format("origin2[0]:%f ",e->origin2[0]);Text+=dummy;};
				if (EntityBitMask[3] & 4)	{dummy.Format("origin2[1]:%f ",e->origin2[1]);Text+=dummy;};
				if (EntityBitMask[3] & 8)	{dummy.Format("origin2[2]:%f ",e->origin2[2]);Text+=dummy;};
				if (EntityBitMask[3] & 16)	{dummy.Format("angles[0]:%f ",e->angles[0]);Text+=dummy;};
				if (EntityBitMask[3] & 32)	{dummy.Format("angles[1]:%f ",e->angles[1]);Text+=dummy;};
				if (EntityBitMask[3] & 64)	{dummy.Format("angles[2]:%f ",e->angles[2]);Text+=dummy;};
				if (EntityBitMask[3] & 128)	{dummy.Format("angles2[0]:%f ",e->angles2[0]);Text+=dummy;};
				if (EntityBitMask[4] & 1)	{dummy.Format("angles2[1]:%f ",e->angles2[1]);Text+=dummy;};
				if (EntityBitMask[4] & 2)	{dummy.Format("angles2[2]:%f ",e->angles2[2]);Text+=dummy;};
				if (EntityBitMask[4] & 4)	{dummy.Format("otherEntityNum:%u ",e->otherEntityNum);Text+=dummy;};
				if (EntityBitMask[4] & 8)	{dummy.Format("otherEntityNum2:%u ",e->otherEntityNum2);Text+=dummy;};
				if (EntityBitMask[4] & 16)	{dummy.Format("groundEntityNum:%u ",e->groundEntityNum);Text+=dummy;};
				if (EntityBitMask[4] & 32)	{dummy.Format("loopSound:%u ",e->loopSound);Text+=dummy;};
				if (EntityBitMask[4] & 64)	{dummy.Format("constantLight:%u ",e->constantLight);Text+=dummy;};
				if (EntityBitMask[4] & 128)	{dummy.Format("modelindex:%u ",e->modelindex);Text+=dummy;};
				if (EntityBitMask[5] & 1)	{dummy.Format("modelindex2:%u ",e->modelindex2);Text+=dummy;};
				if (EntityBitMask[5] & 2)	{dummy.Format("frame:%u ",e->frame);Text+=dummy;};
				if (EntityBitMask[5] & 4)	{dummy.Format("clientNum:%u ",e->clientNum);Text+=dummy;};
				if (EntityBitMask[5] & 8)	{dummy.Format("solid:%u ",e->solid);Text+=dummy;};
				if (EntityBitMask[5] & 16)	{dummy.Format("event:%u ",e->event);Text+=dummy;};
				if (EntityBitMask[5] & 32)	{dummy.Format("eventParm:%u ",e->eventParm);Text+=dummy;};
				if (EntityBitMask[5] & 64)	{dummy.Format("powerups:%u ",e->powerups);Text+=dummy;};
				if (EntityBitMask[5] & 128)	{dummy.Format("weapon:%u ",e->weapon);Text+=dummy;};
				if (EntityBitMask[6] & 1)	{dummy.Format("legsAnim:%u ",e->legsAnim);Text+=dummy;};
				if (EntityBitMask[6] & 2)	{dummy.Format("torsoAnim:%u ",e->torsoAnim);Text+=dummy;};
				g_DebugText+=Text+"\x0D\x0A";
			}	// debug	*/

			
		}
		else
		{
			if (debug) g_DebugText+=" Copy old Entity.\x0D\x0A";
			memcpy(e,olde,sizeof(entityState_t));
			e->number=EntityIndex;
		}
	}

};

// parsed  die alle entities im snapshot s und benutzt ds als deltasnapshot, falls ds!=NULL
void ParseDeltaEntities(CPacket * p, snapshot_t * s, snapshot_t * ds)
{
	int		zaehler=0;			// zhler der mit den delta entities hochzhlt
	int		index=0;			// der neu gelesene index 10 bit
	int		ds_entity_num;		// entity nummer des aktuellen delta entity
	entityState_t * ds_entity;	// das aktuelle delta entity
	char	dummy[255];			// temp string fr debug texte
	bool	debug = g_Options.DebugActive && g_Options.DebugShowEntities;	// so gehts schneller

	s->ringbuff_pos=g_ringbuff_pos;	// position im ringbuffer des neuen pakets ist seine aktuelle Position
	s->numEntities=0;				// es wurden noch keine entities gelesen

	if (ds==NULL)	// falls kein delta snapshot vorhanden
	{
		ds_entity_num=99999;	// markiere als nodelta
	}
	else
	{
		if (ds->numEntities==0)	// hat das delta snapshot selbst keine Entities ?
		{
			ds_entity_num=99999;	// markiere als nodelta
		}
		else
		{
			ds_entity=&g_ringbuff[ds->ringbuff_pos & 0x7FF];		// hole das 1. entity
			ds_entity_num=g_ringbuff[ds->ringbuff_pos & 0x7FF].number;	// und seine Eigentliche Entity nummer		
		}
	}

	// START
	// EndOfPacket(p) check einbauen TODO FIXME

	while(ENTITYNUM_NONE!=(index=p->ReadnBits(10)))	// solange der gerade gelesene index !=1023
	{
		while (ds_entity_num<index)	// solange noch delta entities vor diesem index im delta snapshot sind
		{
			// " unchanged ds_entity_num"
			if (debug)
			{
				sprintf(dummy,"unchanged: %u\x0D\x0A",ds_entity_num);
				g_DebugText+=dummy;
			};

			memcpy(&g_ringbuff[g_ringbuff_pos & 0x7FF],ds_entity,sizeof(entityState_t));	// bernimm entity daten
			if (g_ringbuff[g_ringbuff_pos & 0x7FF].number!=1023)
			{
				g_ringbuff_pos++;	// falls kein dummy entity 1023 kopiert wurde
				s->numEntities++;	// erhhe die position und den zhler
			}

			zaehler++;	// im delta packet in entity weiter

			if (zaehler<ds->numEntities)	// bin ich noch nicht beim letzten delta entity
			{
				ds_entity_num=g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF].number;
				ds_entity=&g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF];
			}
			else
				ds_entity_num=99999;	//tja ab jetzt keine delta entities mehr

		}	// while (ds_entity_num<index)

		if (ds_entity_num==index)	// eine vorhandes delta entity wird verndert
		{
			// "delta: index"
			if (debug)
			{
				sprintf(dummy,"delta: %u",index);
				g_DebugText+=dummy;
			}

			ParseEntity(p,index,&g_ringbuff[g_ringbuff_pos & 0x7FF],ds_entity);
			//if (ds_entity->number!=1023)	// oder gleich ds_entity_num	
			if (g_ringbuff[g_ringbuff_pos & 0x7FF].number != 1023)	// oder gleich ds_entity_num	TODO FIXME
			{
				g_ringbuff_pos++;
				s->numEntities++;
			}

			zaehler++;

			if (zaehler<ds->numEntities)	// bin ich noch nicht beim letzten delta entity
			{
				ds_entity_num=g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF].number;
				ds_entity=&g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF];
			}
			else
			{
				ds_entity_num=99999;	//tja ab jetzt keine delta entities mehr
			}
		}
		else
		{
			// "baseline <index>
			if (debug)
			{
				sprintf(dummy,"baseline: %u",index);
				g_DebugText+=dummy;
			}

			// hole dir hier als delta vorlage ein entity aus der baseline
			ParseEntity(p,index,&g_ringbuff[g_ringbuff_pos & 0x7FF],&g_baseline[index]);
			if (g_ringbuff[g_ringbuff_pos & 0x7FF].number != 1023)
			{
				g_ringbuff_pos++;
				s->numEntities++;
			}

			// da gier kein delta entity aus dem delta snapshot gelesen wurde
			// brauch auch kein neues gestzt werden
		}

	} //while(1023!=(index=ReadnBits(p,10)))
	
	// falls delta snapshot mssen noch die restlichen entities unverndert bernommen werden
	// if (ds_entity_num==99999)	return;	// keine delta entities mehr vorhanden

	while (ds_entity_num!=99999)
	{
		// "unchanged: ds_entity_num"
		if (debug)
		{
			sprintf(dummy,"unchanged: %u\x0D\x0A",ds_entity_num);
			g_DebugText+=dummy;
		}

		memcpy(&g_ringbuff[g_ringbuff_pos & 0x7FF],ds_entity,sizeof(entityState_t));	// bernimm entity daten

		if (g_ringbuff[g_ringbuff_pos & 0x7FF].number!=1023)
		{
			g_ringbuff_pos++;	// falls kein dummy entity 1023 kopiert wurde
			s->numEntities++;	// erhhe die position und den zhler
		}

		zaehler++;	// im delta packet ein entity weiter

		if (zaehler<ds->numEntities)	// bin ich noch nicht beim letzten delta entity
		{
			ds_entity_num=g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF].number;
			ds_entity=&g_ringbuff[(ds->ringbuff_pos+zaehler) & 0x7FF];
		}
		else
			return;	// das letzte delta entity wurde bereits kopiert
	}

}	

void GameUpdateSnapshot(snapshot_t * s)
{
	int i=0;
	WORD zonex,zoney;
	int pos=0;
	int clientNumber = s->ps.clientNum;	// client number
	float meters;
	float fx,fy,fz;

	entityState_t * entityState;	
	centity_t    * centity;

	// liste der alten entites eine Einheit "lter machen"
	for(i=0;i<MAX_GENTITIES;i++)
		if (g_cg_entities[i].currentValid>0) 
			g_cg_entities[i].currentValid--;	// gltigkeits zeit um 1 verkrzen
		else
			memset(&g_cg_entities[i],0,sizeof(centity_t));	// komplett lschen, falls nicht mehr aktuell
	

	// spieler in Entity umwandeln, nchstes im ringbuffer
	entityState= &g_ringbuff[g_ringbuff_pos & 0x7FF];
	BG_PlayerStateToEntityState(&g_cgs.snap->ps,entityState);
	g_ringbuff_pos++;

	// spieler die client entity liste updaten
	for(i=0;i<s->numEntities+1;i++)
	{
		pos=s->ringbuff_pos+i;	// entity pos im ringbuffer
		entityState = &g_ringbuff[pos & 0x7FF];	// das eigentliche entity
		centity = &g_cg_entities[entityState->number];

		// auf anzahl der spieler valid setzen damit es nach genau einem cycle rausfliegt
		// TODO FIXME spieler sollte dopplet so hoch validrate bekommen, da si nicht sprungartig wie items verschwinden
		centity->currentValid=g_cgs.clientnum;		

		// zeiger auf das entity_stateobjekt
		centity->currentState=s->ringbuff_pos+i;	

		CG_CheckEvents(centity);

		// 2D Position in map berechnen
		// auf betrachter ausrichten
		fx = entityState->pos.trBase[0] - g_ViewX;
		fy = entityState->pos.trBase[1] - g_ViewY;
		fz = MAP_PROPORTION / (entityState->pos.trBase[2] - g_ViewZ);

		// projezieren Dir 0
		if (g_ViewDir==0)
		{
			centity->mapx = 320 - fy*fz;
			centity->mapy = 240 - fx*fz;
	
		}
		else
		{
			centity->mapx = 320 + fx*fz;
			centity->mapy = 240 - fy*fz;
		};

		// zur domination gehren nur lebende, aktive spieler die nicht sprechen oder verbindungsprobleme haben
		if (entityState->eType==ET_PLAYER && entityState->weapon!=WP_NONE && !(entityState->eFlags & EF_TALK) && !(entityState->eFlags & EF_CONNECTION)&& !(entityState->eFlags & EF_DEAD) )
		{
			zonex = centity->mapx >>3;
			zoney = centity->mapy >>3;

			if (zonex<80 && zoney < 60)
				g_statistics.zones[zonex][zoney][g_cgs.clientinfo[entityState->clientNum].team & 1]++;

		}
	
	}
	
				


	// statsitsche Daten aus snapshot hinzufgen
	// hole richtigen plaer statistic eintrag
	playerStatistic_t * statistics = &g_statistics.players[clientNumber];	// aktuelle spieler statistic

	// daten nur von lebenden spielern erfassen
	if (s->ps.stats[STAT_HEALTH]>0)
	{
		// falls die letzten werte gltig)
		if (statistics->lastUpdate>0)
		{
			float	xdiff,ydiff,zdiff;
			int		timediff;
			xdiff = statistics->lastPosition[0]-s->ps.origin[0];
			ydiff = statistics->lastPosition[1]-s->ps.origin[1];
			zdiff = statistics->lastPosition[2]-s->ps.origin[2];

			timediff = s->serverTime-statistics->lastUpdate;

			meters= (sqrt(xdiff*xdiff+ydiff*ydiff+zdiff*zdiff)*500) / timediff;

			StatisticUpdateValue(&statistics->movement,int(meters));
		}

	
		StatisticUpdateValue(&statistics->armor,s->ps.stats[STAT_ARMOR]);
		StatisticUpdateValue(&statistics->health,s->ps.stats[STAT_HEALTH]);
	
		statistics->lastUpdate=s->serverTime;
		VectorCopy(s->ps.origin,statistics->lastPosition);
	}
	else
		statistics->lastUpdate=0;	// wieder zurck setzen

}

void GameUpdatePlayer(char * string, clientInfo_t * client)
{
	char * CleanName;

	if ( !string[0])	// wenn string leer lsche alle daten
	{
		memset( client, 0, sizeof(clientInfo_t) );
		client->DataChanged=true;	
		g_cgs.clientnum--;	// spielerzahl erniedrigen
		return;		// player just left
	}

	char	*slash;	// slash position im modelname bsp: RANGER\WRACK = MODEL\SKIN

	// isolate the player's name
	CleanName = Info_ValueForKey(string, "n");
	CleanString(CleanName);
	strcpy(client->name,CleanName);
	
	// colors
	client->color = atoi(Info_ValueForKey(string, "c1" ));
	
	// bot skill
	client->botSkill = atoi(Info_ValueForKey(string, "skill" ));
	
	// handicap
	client->handicap = atoi(Info_ValueForKey(string, "hc" ));
	
	// wins
	client->wins = atoi(Info_ValueForKey(string, "w" ));
	
	// losses
	client->losses = atoi(Info_ValueForKey(string, "l" ));
	
	// team
	client->team = atoi(Info_ValueForKey(string, "t" ));
	
	// model
	strcpy(client->modelName,Info_ValueForKey(string, "model" ));
	
	slash = strchr( client->modelName, '/' );	// such / im string
	if ( !slash ) 
	{
		// modelName didn not include a skin name
		strcpy(client->skinName,"default");
	}
	else 
	{
		strcpy(client->skinName,slash + 1);
		// truncate modelName
		*slash = 0;
	}

	if (client->used==false)	// da ist ein neuer spieler
	{
		g_cgs.clientnum++;	// spielerzahl erhhen
		client->gameEntered = g_cgs.ServerTime;	// aktuelle zeit als tiem entered
		client->used=true;
		client->rank=-1;
	}
	
	client->DataChanged=true;	

};

// bertragt die daten aus den configstrings ins spiel
// das kann eine sehr lange funktion werden

void ParseConfigString(int index, char * string)	
{
	g_cgs.ConfigStringUpdate=true;	// wahrscheinlich wird sich was nderen

	if (index<CS_MODELS)
	{
		switch(index)
		{
			case CS_SERVERINFO	:	g_cgs.gametype = atoi( Info_ValueForKey(string, "g_gametype" ) );
									g_cgs.dmflags = atoi( Info_ValueForKey(string, "dmflags" ) );
									g_cgs.teamflags = atoi( Info_ValueForKey(string, "teamflags" ) );
									g_cgs.fraglimit = atoi( Info_ValueForKey(string, "fraglimit" ) );
									g_cgs.capturelimit = atoi( Info_ValueForKey(string, "capturelimit" ) );
									g_cgs.timelimit = atoi( Info_ValueForKey(string, "timelimit" ) );
									g_cgs.maxclients = atoi( Info_ValueForKey(string, "sv_maxclients" ) );
									g_cgs.protocol = atoi( Info_ValueForKey(string, "protocol" ) );
									
									strcpy(g_cgs.version,Info_ValueForKey(string, "version" ));
									strcpy(g_cgs.mapname,Info_ValueForKey(string, "mapname" ));
									strcpy(g_cgs.sv_hostname,Info_ValueForKey(string, "sv_hostname" ));

									break;

			case CS_SYSTEMINFO	:	g_cgs.sv_cheats = atoi(Info_ValueForKey(string, "sv_cheats" ) );
									g_cgs.sv_pure = atoi(Info_ValueForKey(string, "sv_pure" ) );
									g_cgs.sv_serverid = atoi(Info_ValueForKey(string, "sv_serverid" ) );
									strcpy(g_cgs.sv_referencedPaks,Info_ValueForKey(string, "sv_referencedPaks"));
									
									break;

			case CS_MUSIC				:	strcpy(g_cgs.music,string);break;		
			case CS_MESSAGE				:	strcpy(g_cgs.message,string);break;
			case CS_MOTD				:	strcpy(g_cgs.motd,string);break;
			case CS_WARMUP				:	g_cgs.warmup=atoi(string);break;
			case CS_SCORES1				:	g_cgs.scores1=atoi(string);break;
			case CS_SCORES2				:	g_cgs.scores2=atoi(string);break;
			case CS_VOTE_TIME			:	g_cgs.voteTime=atoi(string);break;
			case CS_VOTE_STRING			:	strcpy(g_cgs.voteString,string);break;
			case CS_VOTE_YES			:	g_cgs.voteYes=atoi(string);break;
			case CS_VOTE_NO				:	g_cgs.voteNo=atoi(string);break;
			case CS_GAME_VERSION		:	break;
			case CS_LEVEL_START_TIME	:	g_cgs.levelStartTime=atoi(string);break;
			case CS_INTERMISSION		:	g_cgs.intermission=atoi(string);break;
			case CS_FLAGSTATUS			:	g_cgs.redflag = string[0] - '0'; g_cgs.blueflag = string[1] - '0';break;
			case CS_ITEMS				:	strcpy(g_cgs.items,string);break;
		}

		return;	// fertig
	}

	if (index<CS_SOUNDS)	// da >= models und<Sounds ist es ein Modelindex
	{
		// mach was mit dem modelindex
		return;
	}
	
	if(index<CS_PLAYERS)
	{
		// soundindex brauche icht nicht
		return;
	}

	if(index<CS_LOCATIONS)
	{
		// playerindex, schon interssanter
		index-=CS_PLAYERS;	// berechne clientnumber
		GameUpdatePlayer(string,&g_cgs.clientinfo[index]);	// ndere vorhandene daten

		// falls es mein ARGUS ist setzt ARGUS spieler nummer
		if (g_cgs.clientinfo[index].team==TEAM_SPECTATOR && !strcmp(g_cgs.clientinfo[index].name,"ARGUS"))
			g_cgs.ArgusPlayerNum=index;

		g_cgs.PlayerInfoUpdate=true;
		return;
	}

	if(index<CS_MAX)
	{
		// locations index
		return;
	}

	// wenn man bis hier kommt ist was faul
	ConsolePrint("ConfigString Index >= CS_MAX !");


}

void BG_PlayerStateToEntityState( playerState_t *ps, entityState_t *s)
{
	int		i;

	if ( ps->pm_type == PM_INTERMISSION || ps->pm_type == PM_SPECTATOR )
	{
		s->eType = ET_INVISIBLE;
	}
/*	else if ( ps->stats[STAT_HEALTH] <= GIB_HEALTH )
	{
		// s->eType = ET_INVISIBLE;
		s->eType = ET_PLAYER;
	} */ // ich will die spieler auch als leichen sehen slebst wenn sie total zergibbt sind
	else
	{
		s->eType = ET_PLAYER;
	}

	s->number = ps->clientNum;

	s->pos.trType = TR_INTERPOLATE;
	VectorCopy( ps->origin, s->pos.trBase );
	
	s->apos.trType = TR_INTERPOLATE;
	VectorCopy( ps->viewangles, s->apos.trBase );
	
	s->angles2[YAW] = ps->movementDir;
	s->legsAnim = ps->legsAnim;
	s->torsoAnim = ps->torsoAnim;
	s->clientNum = ps->clientNum;		// ET_PLAYER looks here instead of at number
										// so corpses can also reference the proper config
	s->eFlags = ps->eFlags;
	if ( ps->stats[STAT_HEALTH] <= 0 ) {
		s->eFlags |= EF_DEAD;
	} else {
		s->eFlags &= ~EF_DEAD;
	}

	if ( ps->externalEvent ) {
		s->event = ps->externalEvent;
		s->eventParm = ps->externalEventParm;
	} else {
		int		seq;

		seq = (ps->eventSequence-1) & (MAX_PS_EVENTS-1);
		s->event = ps->events[ seq ] | ( ( ps->eventSequence & 3 ) << 8 );
		s->eventParm = ps->eventParms[ seq ];
	}

	s->weapon = ps->weapon;
	s->groundEntityNum = ps->groundEntityNum;

	s->powerups = 0;
	for ( i = 0 ; i < MAX_POWERUPS ; i++ ) {
		if ( ps->powerups[ i ] ) {
			s->powerups |= 1 << i;
		}
	} 

}

void ParseGameState(CPacket * p)
{
	DWORD dw;
	BYTE command;
	WORD Index;
	CString dummy,dummy2;
	char configstring[0x800];
	bool debug = g_Options.DebugActive && g_Options.DebugShowGamestate;

	entityState_t NullEntity;	// ein leeres entity
	memset(&NullEntity,0,sizeof(NullEntity));	// so, jetzt ist es wirklich leeer
	
	GameInit(g_cgs.processedSnapshotNum ,g_cgs.serverCommandSequence );	// spieleinstellungen zurcksetzen
	

	if (debug) g_DebugText+="GAMESTATE\x0D\x0A";
	
	dw=p->ReadDWord();	// unknown wird weggespeichert
	if (debug)
	{
		dummy.Format("DWord: %u\x0D\x0A",dw);
		g_DebugText+=dummy;
	}

	command=p->ReadByte();
	while (command!=0)
	{
		switch (command)
		{
			case 3 :	Index=p->ReadWord();		// lies configstring index
						if (Index>MAX_CONFIGSTRINGS)  ConsolePrint("Configstring Index too high !\x0D\x0A");
						p->ReadString(configstring);
						ParseConfigString(Index,configstring);
						if (g_Debug) ConsolePrint(configstring);
						if (debug)
						{
							dummy.Format("Configstring[%u] %s\x0D\x0A",Index,configstring);
							g_DebugText+=dummy;
						};
						
						break;
		

			case 4 :	Index=p->ReadnBits(10);	// lies baseline number
						if ( (Index==0) || (Index>MAX_BASLINE_ENTITIES) ) ConsolePrint("Baseline number out of range !");

						ParseEntity(p,Index,&g_baseline[Index],&NullEntity);	// lies das entsprechende Entity in die Baseline
						break;

			default:	ConsolePrint("Bad Gamestat command byte !");break;
		}

		// NextFullByte();

		
		

		command=p->ReadByte();	// nchsten svc nr lesen
	} 

	g_cgs.receivedGameState=true;	// alle notwendigen informationen sind da

	// so grundstzlich spieldaten sind gelesen, gui informieren
	::PostMessage((HWND)g_CallingDialogHandle,WM_GAME_RESTART,0,0);	// Programm benachrichtigen

}

void ParseSnapshot(CPacket * p)
{
	char dummy[255];
	BYTE delta,b,b2;
		
	WORD mask = 0;
	int i,min,sek, deltaSeqNr;

	snapshot_t * s;		// der aktuelle snapshot
	snapshot_t * ds;	// der passende Delta snapshot
	
	
	bool debug=g_Options.DebugActive; // && g_Options.DebugHSowSnapshots

	// merke aktuellen als letzten
	g_cgs.lastSnap = g_cgs.snap;

	//  berechne Position des neuen snaphot
	s = &g_snapshotbuffer[p->SequenceNumber & 0x1F];	// maskieren da 32 Snapshots im buffer
	g_cgs.snap=s;	// jetzt dem spiel den neuen snapshot auch mitteilen

	s->seqNr=p->SequenceNumber;	// dem snap auch sagen zu wem er genau gehrt
		

	if (debug) g_DebugText+="SNAPSHOT\x0D\x0A";

	s->numServerCommands=p->ReadDWord();	// zuletzt empfangen client command nr
	g_cgs.clientCommandSequence=s->numServerCommands;	// global gltig

	s->serverTime=p->ReadDWord();	// lies serverzeit

	g_cgs.lastSnapshotTime=g_cgs.ServerTime;	// merke letzte zeit
	g_cgs.ServerTime=s->serverTime;		// global gltig

	delta=p->ReadByte();	// Detlaframe=Sequenznumber - DeltaComprssion oder -1 falls Deltacompression = 0
	
	if (debug)
	{
		min = s->serverTime/ 60000;
		sek = (s->serverTime / 1000) -min*60;
		sprintf(dummy,"ClientCmdNr %i, Time %.4u:%.2u Delta %u\x0D\x0A",s->numServerCommands,min,sek,delta);
		g_DebugText+=dummy;
	}

	// berechne delta snapshot
	if (delta)
	{
		deltaSeqNr=(p->SequenceNumber-delta);		// erstmal die richtige delta snapshot nummer ausrechen
		ds = &g_snapshotbuffer[deltaSeqNr & 0x1F];	// maskiert aus dem buffer holen
		if (ds->seqNr!=deltaSeqNr) ConsolePrint("Delta frame too old.\x0D\x0A");
		if (g_ringbuff_pos - ds->ringbuff_pos > 1920 ) ConsolePrint("Delta parseEntitiesNum too old.\x0D\x0A");
		memcpy(&s->ps,&ds->ps,sizeof(playerState_t));	// von mir alte player infos bernehmen
	}
	else
	{
		memset(&s->ps,0,sizeof(playerState_t));	// von mir
		ds=NULL;	// kein delta snapshot;
	}

	b=p->ReadByte();	// hat irgendwas mit delta zu tun sollte nicht 0 sein
	
	b=p->ReadByte();	
	// hier wird der Packetbitzhler in source code auf die nchste volle Byzepos gesetz ist aber nie ntig FIXME TODO
	for (i=0;i<b;i++)
	{
		
		b2=p->ReadByte();	// wird hinetereiander abgespeichert bedeutung unklar
		if (debug)
		{
			sprintf(dummy,"Byte %u\x0D\x0A",b2);
			g_DebugText+=dummy;
		}
	}

	// lies Playerstate

	if(p->ReadBit()) s->ps.commandTime=		p->ReadnBits(32);
	if(p->ReadBit()) s->ps.pm_type=			p->ReadnBits(8);
	if(p->ReadBit()) s->ps.bobCycle=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.pm_flags=		p->ReadnBits(16);
	if(p->ReadBit()) s->ps.pm_time=			p->ReadnBits(16);
	if(p->ReadBit()) s->ps.origin[0]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.origin[1]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.origin[2]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.velocity[0]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.velocity[1]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.velocity[2]=		p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.weaponTime=		p->ReadnBits(16);
	if(p->ReadBit()) s->ps.gravity=			p->ReadnBits(16);
	if(p->ReadBit()) s->ps.speed=			p->ReadnBits(16);
	if(p->ReadBit()) s->ps.delta_angles[0]=	p->ReadnBits(16);
	if(p->ReadBit()) s->ps.delta_angles[1]=	p->ReadnBits(16);
	if(p->ReadBit()) s->ps.delta_angles[2]=	p->ReadnBits(16);
	if(p->ReadBit()) s->ps.groundEntityNum=	p->ReadnBits(10);
	if(p->ReadBit()) s->ps.legsTimer=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.torsoTimer=		p->ReadnBits(12);	
	if(p->ReadBit()) s->ps.legsAnim=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.torsoAnim=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.movementDir=		p->ReadnBits(4);
	if(p->ReadBit()) s->ps.eFlags=			p->ReadnBits(16);
	if(p->ReadBit()) s->ps.eventSequence=	p->ReadnBits(16);
	if(p->ReadBit()) s->ps.events[0]=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.events[1]=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.eventParms[0]=	p->ReadnBits(8);
	if(p->ReadBit()) s->ps.eventParms[1]=	p->ReadnBits(8);
	if(p->ReadBit()) s->ps.externalEvent=	p->ReadnBits(8);
	if(p->ReadBit()) s->ps.externalEventParm=	p->ReadnBits(8);
	if(p->ReadBit()) s->ps.clientNum=		p->	ReadnBits(8);
	if(p->ReadBit()) s->ps.weapon=			p->ReadnBits(5);
	if(p->ReadBit()) s->ps.weaponstate=		p->ReadnBits(4);
	if(p->ReadBit()) s->ps.viewangles[0]=	p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.viewangles[1]=	p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.viewangles[2]=	p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.viewheight=		p->ReadnBits(8);
	if(p->ReadBit()) s->ps.damageEvent=		p->ReadnBits(8);		
	if(p->ReadBit()) s->ps.damageYaw=		p->ReadnBits(8);			// richtung aus der letzter scahden entstand
	if(p->ReadBit()) s->ps.damagePitch=		p->ReadnBits(8);		// richtung aus der letzter scahden entstand
	if(p->ReadBit()) s->ps.damageCount=		p->ReadnBits(8);		// wie stark der letzte Schaden war
	if(p->ReadBit()) s->ps.grapplePoint[0]=	p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.grapplePoint[1]=	p->ReadPackedFloat();
	if(p->ReadBit()) s->ps.grapplePoint[2]=	p->ReadPackedFloat();

	sprintf(dummy,"ps.clientNum %i\x0D\x0A",s->ps.clientNum);
	g_DebugText+=dummy;

	if (p->ReadBit())		// PS_STATS
	{
		mask=p->ReadWord();
		for (i=0;i<MAX_STATS;i++)
			if ((mask&(1<<i))!=0)	// bit gesetzt ?
			{
				s->ps.stats[i] = p->ReadInt();
				
				if (debug && g_Options.DebugShowPlayerstatus)
				{
					sprintf(dummy,"PS_Stats%u:%i\x0D\x0A",i,s->ps.stats[i]);
					g_DebugText+=dummy;
				}
			}
	}

	if (p->ReadBit())	// PS_Persistant
	{
		mask=p->ReadWord();
		for (i=0;i<MAX_PERSISTANT;i++)
			if ((mask&(1<<i))!=0)	// bit gesetzt ?
			{
				s->ps.persistant[i] = p->ReadWord();

				if (debug && g_Options.DebugShowPlayerstatus)
				{
					sprintf(dummy,"PS_Persistant%u:%u\x0D\x0A",i,s->ps.persistant[i]);
					g_DebugText+=dummy;
				}
			}
	}

	if (p->ReadBit())	// PS_Ammo
	{
	
		mask=p->ReadWord();
		for (i=0;i<MAX_WEAPONS;i++)
			if ((mask&(1<<i))!=0)	// bit gesetzt ?
			{
				s->ps.ammo[i] = p->ReadWord();
				if (debug && g_Options.DebugShowPlayerstatus)
				{
					sprintf(dummy,"PS_Ammo%u:%u\x0D\x0A",i,s->ps.ammo[i]);
					g_DebugText+=dummy;
				}
			}
	}

	if (p->ReadBit())	// PS_Powerups
	{
		mask=p->ReadWord();
		for (i=0;i<MAX_POWERUPS;i++)
			if ((mask&(1<<i))!=0)	// bit gesetzt ?
			{
				s->ps.powerups[i] = p->ReadDWord();	// ACHTUNG bei powerups 32 Bit lesen nicht 16
				if (debug && g_Options.DebugShowPlayerstatus)
				{
					sprintf(dummy,"PS_Powerups%u:%u\x0D\x0a",i,s->ps.powerups[i]);
					g_DebugText+=dummy;
				}
			}
	}

	 ParseDeltaEntities(p,s,ds);	// so eine kleine Zeile kann so viel rger machen

	 // so snapshot komplett geparsed, jetzt aus werten

	 GameUpdateSnapshot(s);

}

void CleanString(char * string)	// entfernt " \n und faben ^1
{
	if (strlen(string)==0) return;

	char * pos = string;

	while (*pos!=0)
	{
		if (*pos=='^')
		{
			*pos='"';pos++;*pos='"';	// auch das farbebzeichen lschen	
		}
		if (*pos=='\n')
		{
			*pos='"';	// auch das farbebzeichen lschen	
		}

		pos++;	// nchstes zeichen
	}

	CString Dummy=string;
	Dummy.Remove('"');		// so alle platzhalter lschen
	strcpy(string,Dummy);	// ordentlichen string zurckkopieren
}

char * GetArg(char * string, int nr)
{
	static char buffer[1024];	// static damit die bergaben icht auf dem stack kaputtgemacht wird
	bool instring=false;	// ob er gerade zwischen zwei " ist
	char * pos;
	char * start;
	int found=0;
	
	strcpy(buffer,string);
	pos=buffer;

	if (string==NULL) return NULL;

	while (*pos!=0 && found<nr)
	{
		if (*pos=='"') instring=!instring;	// falls man in einen string kommt gelten die spaces nicht
		if (*pos==' ' && !instring) found++;
		pos++;
	}
	start=pos;	// anfang des n. arguments schon gefunden
	
	while (*pos!=0 && found==nr)
	{
		if (*pos=='"') instring=!instring;	// falls man in einen string kommt gelten die spaces nicht
		if (*pos==' ' && !instring) found++;
		pos++;
	};

	if (found!=nr)
	{
		pos--;
		*pos=0;	// ende setzen im buffer
	};

	return start;

}

void ParseScoreString(char * string)
{
	int		i, powerups,clientnr,ping,time,scoreFlags;
	int		numScores = atoi( GetArg(string,1) );

	playerStatistic_t * ps;

	if ( numScores > MAX_CLIENTS ) 
		numScores = MAX_CLIENTS;
	char	buffer[1024];
	
	g_cgs.TeamScores[0] = atoi( GetArg(string,2) );
	g_cgs.TeamScores[1] = atoi( GetArg(string,3) );

	for ( i = 0 ; i < numScores ; i++ )
	{
		// das hier ist ziemlich zu langsam
		clientnr	= atoi( GetArg(string,i * 6 + 4 ) );
		g_cgs.clientinfo[clientnr].rank = i;
		g_cgs.clientinfo[clientnr].score = atoi( GetArg(string,i * 6 + 5 ) );
		ping		= atoi( GetArg(string,i * 6 + 6 ) );
		time		= atoi( GetArg(string,i * 6 + 7 ) );
		scoreFlags	= atoi( GetArg(string,i * 6 + 8 ) );
		powerups	= atoi( GetArg(string,i * 6 + 9 ) );
	
		// sprintf(buffer,"%s: Score %i, Ping %i, Time %i, SFlags %i, Powerups %i",g_cgs.clientinfo[clientnr].name,score,ping,time,scoreFlags,powerups);
		
		ps = &g_statistics.players[clientnr];

		StatisticUpdateValue(&ps->ping,ping);
		StatisticUpdateValue(&ps->rank,i);	// score table ist nach ranking sortiert
		StatisticUpdateValue(&ps->score,g_cgs.clientinfo[clientnr].score);
		ps->time=time;



	}

}

void ParseServerCommand(CPacket * p)
{
	char cmd[4096];
	char param[4096];
	char servercommand[4096];
	int index=0;

	CString dummy;
	DWORD cmdnr=p->ReadDWord();	// lies command nummer

	p->ReadString(servercommand);	// lies cammond

	if (cmdnr<=g_cgs.serverCommandSequence)
	{	// ConsolePrint("Old Command sequence number");
		return;	// verwirf alte commandos
	}

	g_cgs.serverCommandSequence=cmdnr;	// setze neue command nummer als die aktuelle
	
	if (g_Options.DebugActive && g_Options.DebugShowServercommand) 
	{
		dummy.Format("SERVERCOMMAND %u %s\x0D\x0A",g_cgs.serverCommandSequence,servercommand);g_DebugText+=dummy;
	}

	strcpy(cmd,GetArg(servercommand,0));	// erstes arguemnt
	strcpy(param,GetArg(servercommand,1));	// zweites argument
	CleanString(param);		// string von steuerzeichen befreien
		
	if ( !cmd[0] ) return;	// server claimed the command

	if ( !strcmp( cmd, "cp" ) ) {
		ConsolePrint(param);
		return;
	}

	if ( !strcmp( cmd, "cs" ) ) {
		index=atoi(param);
		strcpy(param,GetArg(servercommand,2));	// zweites argument
		CleanString(param);		// string von steuerzeichen befreien
		ParseConfigString(index,param);
		return;
	}

	if ( !strcmp( cmd, "print" ) ) {
		ConsolePrint(param);
		return;
	}

	if ( !strcmp( cmd, "chat" ) )
	{
	
		ConsolePrint(param);
		return;
	}

	if ( !strncmp( cmd, "tchat",5 ) ) {
		ConsolePrint(param);
		return;
	}

	if ( !strncmp( cmd, "scores",6 ) ) {
		ParseScoreString(servercommand);
		return;
	}

	if ( !strncmp( cmd, "tinfo",5 ) ) {
		if (g_Debug) ConsolePrint(param);
		return;
	}

	if ( !strncmp( cmd, "map_restart",11 ) )
	{
		StatisticInit();	// statistiken auch zurcksetzen
		ConsolePrint("Map restart");
		return;
	}

	// loaddeferred can be both a servercmd and a consolecmd
	if ( !strncmp( cmd, "loaddefered",11 ) ) {	// FIXME: spelled wrong, but not changing for demo
		ConsolePrint("loaddfered");
		return;
	}

	// clientLevelShot is sent before taking a special screenshot for
	// the menu system during development
	if ( !strncmp( cmd, "clientLevelShot",15 ) )
	{
		ConsolePrint("Client Level shot");
		return;
	}

	if ( !strncmp( cmd, "disconnect",10 ) ) 
	{	// bei demofile laufe weiter, da hier anders beendet wird (0xFFFFFFFF)
		if (g_DataSourceType!=DS_DEMOFILE)
			g_DataSourceType=DS_NONE;
		ConsolePrint("Client disconnect.");
		return;
	}

	ConsolePrint("Unknown client game command");
	ConsolePrint(cmd);
	ConsolePrint(param);
	
}

void GameInit(int serverSeqNum, int serverCommandSequence )
{
	Sleep(250); // zeitverzgerung

	// aus folgendem grund: falls die grafik routine gerade noch auf diesen daten
	// zeichnet, soll sie erst mal fertig zeichnen damit ihr nicht zwischen drin die
	// daten gelscht werden

	// wenn wenn demo playback und nicht anfang des spiels
	if (serverSeqNum!=0 && serverCommandSequence!=0 && g_DataSourceType==DS_DEMOFILE)
	{
		// erzwinge pause, damit statistik daten nicht futsch sind
		g_DataSourceSpeed=0;
		ConsolePrint("");
		ConsolePrint("Press PLAY to continue game !");
		UpdateGUI();
		
		// warte solange bis pause knopf wieder gedrckt wurde
		while (!g_DataSourceSpeed && g_DataSourceType)
			Sleep(25);
	}

	// Achtung setzt alles auf NULL

	memset(&g_cgs,0,sizeof(g_cgs));
	memset(&g_baseline,0,sizeof(g_baseline));
	memset(&g_cg_entities,0,sizeof(g_cg_entities));
	memset(&g_ringbuff,0,sizeof(g_ringbuff));
	
	g_ringbuff_pos=0;

	memset(&g_snapshotbuffer,0,sizeof(g_snapshotbuffer));

	// zeiger initialisieren
	g_cgs.snap = &g_snapshotbuffer[0];
	g_cgs.lastSnap = &g_snapshotbuffer[0];



	// falls das ein restart ist werden folgende werte bernommen
	g_cgs.processedSnapshotNum = serverSeqNum;
	g_cgs.serverCommandSequence = serverCommandSequence;

	g_cgs.ArgusPlayerNum=-1;	// damit nicht spieler 0 fr argus gehalten wird

	StatisticInit();	// statistiken auch zurcksetzen

}


void GameUpdate(CPacket * p)	// hier kommen neue Packets vom Server rein
{
	CString dummy;
	char command[1024];

	BYTE ServerCommand;

	p->ResetPointer();

	if (p->SequenceNumber!=CONNECTIONLESS_PACKET)
	{
		// packet wird ins temp demo file geschrieben, falls es nicht sowieso schon aus einem kommt

		

		// TODO FIXME suche undichte debugtext stllen die speciherlcher erzeugen
		g_DebugText="";	// imme zurcksetzen da sonst endlos string entstht

		if (g_Options.DebugActive) 
		{
			g_DebugText.Format("SERVER PACKET\x0D\x0ASequence number: %u, Length: %u %s\x0D\x0A",p->SequenceNumber,p->Length, (p->Reliable ? "RELIABLE" : "" ));
		}

		g_cgs.processedSnapshotNum=p->SequenceNumber;	// lasse spiel die aktuelle sequence number wissen

		while ( !p->EndOfPacket())
		{
			ServerCommand=p->ReadByte();	// lies nchsten Servercommand

			switch (ServerCommand)
			{

				case SVC_SNAPSHOT		:ParseSnapshot(p);break;
				case SVC_SERVERCOMMAND	:ParseServerCommand(p);break;		
				case SVC_GAMESTATE		:ParseGameState(p);break;		

				case SVC_BAD			:ConsolePrint("Bad server command.");break;
				case SVC_NOP			:ConsolePrint("NOP server command.");break;		
				case SVC_CONFIGSTRING	:ConsolePrint("Configstring - illegal server command");break;		
				case SVC_BASELINE		:ConsolePrint("Baseline - illegal server command.");break;		
				case SVC_DOWNLOAD		:ConsolePrint("Download - illegal server command.");break;		
				default					:ConsolePrint("Unkown server command.");break;		
			
			}

			p->NextFullByte();	// paketlesezeiger auf nchste volle Byte position setzen
		}  

		StatisticGraphUpdate();	// aktualisiere Graphen
		UpdateGUI();			// informiere GUI ber Update

		if (g_Options.DebugActive) g_DebugText+="END OF PACKET\x0D\x0A\x0D\x0A";


	}
	

}



