/////////////////////////////////////////////
// ARGUS Copyright (C) 1999-2000 Martin Otten
// file : defines.h
// info : defines global constants
/////////////////////////////////////////////


// packet values

#define PROXY_CLIENT_PORT				66666	// port auf dem der Proxy Daten vom Client empfngt
#define PROXY_SERVER_PORT				27966   // port auf dem der proxy daten zum Server sendet
#define SOCKET_BUFFER_SIZE				16768	// Buffer fr eingehende Daten
#define PACKET_FROM_SERVER				1
#define PACKET_FROM_CLIENT				2
#define STANDARD_QUAKE3_SERVER_PORT		27960	
#define CONNECTIONLESS_PACKET			0xFFFFFFFF	

#define MAX_SNAPSHOTS_BUFFERED			32		// anzahl der gebufferten snapshots fr delta (Ringbuffer)
#define	MAX_BASLINE_ENTITIES			1024	// entities der Baseline, also unvernderline Entities die aus der Map kommen und nur einmal beim Gamestate gestzt werden
#define MAX_RINGBUF_ENTITIES			2048	// entities des Ringbuffers in dem alle Snapshots ihr entities ablegen, teilweise aus der Basline kopiert, teilweise aus delta snapshots (ringbuffer)
#define	MAX_CLIENT_COMMANDS				32		// anzahl der client commands, die im buffer liegen knnen

#define MAX_GAMES_IN_DEMO				16		// anzahl der maximal in einem demo enthaltenen spiele

// Server Commands

#define SVC_BAD				0		// ungltiger Server Befehl
#define SVC_NOP				1		// kann einfach berlesen werden
#define SVC_GAMESTATE		2		// startdaten bei spielbeginn: configstrings, entities der baseline
#define SVC_CONFIGSTRING    3		// alter Q2 befehl, jetzt ungltig
#define SVC_BASELINE		4		// alter Q2 befehl, jetzt ungltig
#define SVC_SERVERCOMMAND	5		// server befehler wie print, centerprint, disconnect ...
#define SVC_DOWNLOAD		6		// alter Q2 befehl, jetzt ungltig
#define SVC_SNAPSHOT		7		// beschreibung des spielzustands zu einer bestimmten Zeit

// key server data
#define KEY_SERVER_IP		"authorize.quake3arena.com"
#define KEY_SERVER_PORT		27952

// timer constants
#define TIMER_GUI			1		// wird bei SetTimer benutzt
#define TIMER_GRAPHIC		2		// wird bei SetTimer benutzt

// user Window Messages

#define WM_UPDATE_GUI			WM_USER+601	// Falls die gui,console, stats, onstig relative "langsame daten" neu sind
#define WM_UPDATE_GRAPHIC		WM_USER+602	// falls relative "schnelle daten" Spieler /items geupdatent wurden

#define WM_GAME_INTERMISSION	WM_USER+603	// falls die datensourec eine unterbrechnung meldet, kann nur durch restart aufgelst werden
#define WM_GAME_RESTART			WM_USER+604	// ein neues spiel beginnt, lade map view neu
#define WM_GAME_DISCONNECT		WM_USER+605	// falls die datasource geschlossen wurde

// data Source Types
#define DS_NONE			0	// keine data source aktiv
#define DS_DEMOFILE		1	// datenstrom kommt aus einem dm3 file
#define DS_PROXY		2	// datenstrom kommt aus dem Proxy
#define DS_CLIENT		3	// die daten kommen direkt von einem Q3 server mit Argus als Client

// Graph value sources 
#define	GS_NONE			0	// kein sample wert
#define GS_SCORE		1	// der score wert
#define GS_HEALTH		2	
#define GS_ARMOR		3
#define GS_PING			4
#define GS_MOVEMENT		5

// anzahl der samples in der graphdarstellung
#define GRAPH_SAMPLES		600


// Math constants

#define MAP_FOV							10				// Aufnahmewinkel der Maps
#define MAP_RESOLUTION					640				// X-Auflsung der Maps
#define MAP_PROPORTION					-3657.6167368836297815074737757321F		// = -(MAP_RESOLUTION/2)/TAN(MAP_FOV/2)

#define CONSOLE_BUFFER_SIZE				65536			// 64 KB konsolen buffer
#define CONSOLE_BUFFER_LINES			1024			// mit 1024 indexierten zeilen
//#define	CONSOLE_LAST_LINES				16				// zeiger auf die letzen 16 Zeilen

// GUI Values fr die verschieden ansichten
#define VIEW_CONSOLE					0
#define	VIEW_MAP						1
#define VIEW_GRAPH						2
#define	VIEW_STATS						3
#define VIEW_DEBUG						4
#define VIEW_NONE						127


#define	SPRITE_EXCELLENT				0	// draw an excellent sprite
#define	SPRITE_GAUNTLET					1	// draw a gauntlet sprite
#define	SPRITE_TALK						2	// draw a talk balloon
#define	SPRITE_CONNECTION				3	// draw a connection trouble sprite
#define	SPRITE_IMPRESSIVE				4	// draw an impressive sprite
#define SPRITE_BLOOD					5	// 
#define SPRITE_SKULL					6	// draw for dead player


#define NEWLINE				"\x0D\x0A" // die newlinezeichen fr static text fields

#define REGISTRYPATH		"SOFTWARE\\Argus"

#define CLIENTVERSION116N	0
#define CLIENTVERSION117	1



/////////////////////////////////////
//	original Quake defines
////////////////////////////////////

// im snapshot
#define	SNAPFLAG_RATE_DELAYED	1
#define	SNAPFLAG_NOT_ACTIVE		2	// snapshot used during connection and for zombies
#define SNAPFLAG_SERVERCOUNT	4	// toggled every map_restart so transitions can be detected

#define	MAX_INFO_STRING		1024	
#define	MAX_INFO_KEY		1024
#define	MAX_INFO_VALUE		1024

#define	MAX_ENTITIES_IN_SNAPSHOT	256

// these aren't needed by any of the VMs.  put in another header?
#define	MAX_MAP_AREA_BYTES		32		// bit vector of area visibility

#define	MAX_GENTITIES		1024
#define	MAX_MODELS			256		// these are sent over the net as 8 bits
#define	MAX_SOUNDS			256		// so they cannot be blindly increased

#define	MAX_GAMESTATE_CHARS	16000
#define	MAX_CONFIGSTRINGS	1024

// these are the only configstrings that the system reserves, all the
// other ones are strictly for servergame to clientgame communication
#define	CS_SERVERINFO		0		// an info string with all the serverinfo cvars
#define	CS_SYSTEMINFO		1		// an info string for server system to client system configuration (timescale, etc)

#define	CS_MUSIC			2		// hintergrundmusik
#define	CS_MESSAGE			3		// from the map worldspawn's message field
#define	CS_MOTD				4		// g_motd string for server message of the day
#define	CS_WARMUP			5		// server time when the match will be restarted
#define	CS_SCORES1			6		// punktestand des besten Spielers	/ team 1
#define	CS_SCORES2			7		// punktestand des zweitbesten spieles	/ team 2
#define CS_VOTE_TIME		8		// wann ist die wahl zu ende ?
#define CS_VOTE_STRING		9		// was wird gewht
#define	CS_VOTE_YES			10		// wieviele Ja-Stimmen
#define	CS_VOTE_NO			11		// wieviel nein-stimmen
#define	CS_GAME_VERSION		12		// baseq3
#define	CS_LEVEL_START_TIME	13		// so the timer only shows the current level
#define	CS_INTERMISSION		14		// when 1, fraglimit/timelimit has been hit and intermission will start in a second or two
#define CS_FLAGSTATUS		15		// string indicating flag status in CTF
#define	CS_ITEMS			27		// string of 0's and 1's that tell which items are present

#define	CS_MODELS			32
#define	CS_SOUNDS			(CS_MODELS+MAX_MODELS)
#define	CS_PLAYERS			(CS_SOUNDS+MAX_SOUNDS)
#define CS_LOCATIONS		(CS_PLAYERS+MAX_CLIENTS)

#define CS_MAX				(CS_LOCATIONS+MAX_LOCATIONS)

// entitynums are communicated with GENTITY_BITS, so any reserved
// values thatare going to be communcated over the net need to
// also be in this range
#define	ENTITYNUM_NONE			(MAX_GENTITIES-1)
#define	ENTITYNUM_WORLD			(MAX_GENTITIES-2)
#define	ENTITYNUM_MAX_NORMAL	(MAX_GENTITIES-2)

#define	MAX_QPATH			64		// max length of a quake game pathname
#define	MAX_OSPATH			128		// max length of a filesystem pathname
#define	MAX_NAME_LENGTH		32		// max length of a client name


// usercmd_t->button bits, many of which are generated by the client system,
// so they aren't game/cgame only definitions
#define	BUTTON_ATTACK		1
#define	BUTTON_TALK			2			// displays talk balloon and disables actions
#define	BUTTON_USE_HOLDABLE	4
#define	BUTTON_GESTURE		8
#define	BUTTON_WALKING		16			// walking can't just be infered from MOVE_RUN
										// because a key pressed late in the frame will
										// only generate a small move value for that frame
										// walking will use different animations and
										// won't generate footsteps
#define	BUTTON_ANY			128			// any key whatsoever

#define	MOVE_RUN			120			// if forwardmove or rightmove are >= MOVE_RUN,
										// then BUTTON_WALKING should be set

// bit field limits playerstats
#define	MAX_STATS				16
#define	MAX_PERSISTANT			16
#define	MAX_POWERUPS			16
#define	MAX_WEAPONS				16		
#define	MAX_PS_EVENTS			2


#define	SNAPFLAG_RATE_DELAYED	1
#define	SNAPFLAG_NOT_ACTIVE		2	// snapshot used during connection and for zombies
#define SNAPFLAG_SERVERCOUNT	4	// toggled every map_restart so transitions can be detected

//
// per-level limits
//
#define	MAX_CLIENTS			128		// absolute limit
#define MAX_LOCATIONS		64

// entityState_t->eFlags
#define	EF_DEAD				0x00000001		// don't draw a foe marker over players with EF_DEAD
#define	EF_TELEPORT_BIT		0x00000004		// toggled every time the origin abruptly changes
#define	EF_AWARD_EXCELLENT	0x00000008		// draw an excellent sprite
#define	EF_BOUNCE			0x00000010		// for missiles
#define	EF_BOUNCE_HALF		0x00000020		// for missiles
#define	EF_AWARD_GAUNTLET	0x00000040		// draw a gauntlet sprite
#define	EF_NODRAW			0x00000080		// may have an event, but no model (unspawned items)
#define	EF_FIRING			0x00000100		// for lightning gun
#define	EF_MOVER_STOP		0x00000400		// will push otherwise
#define	EF_TALK				0x00001000		// draw a talk balloon
#define	EF_CONNECTION		0x00002000		// draw a connection trouble sprite
#define	EF_VOTED			0x00004000		// already cast a vote
#define	EF_AWARD_IMPRESSIVE	0x00008000		// draw an impressive sprite

// playerState_s->powerups
#define	PW_NONE				0
#define	PW_QUAD				1
#define	PW_BATTLESUIT		2
#define	PW_HASTE			3
#define	PW_INVIS			4
#define	PW_REGEN			5
#define	PW_FLIGHT			6
#define	PW_REDFLAG			7
#define	PW_BLUEFLAG			8
#define	PW_BALL				9

// playerstate->weapon
#define	WP_NONE				0
#define	WP_GAUNTLET			1
#define	WP_MACHINEGUN		2
#define	WP_SHOTGUN			3
#define	WP_GRENADE_LAUNCHER 4
#define	WP_ROCKET_LAUNCHER	5
#define	WP_LIGHTNING		6
#define	WP_RAILGUN			7
#define	WP_PLASMAGUN		8
#define	WP_BFG				9
#define	WP_GRAPPLING_HOOK	10
	
// reward sounds
#define	REWARD_BAD			0
#define	REWARD_IMPRESSIVE	1
#define	REWARD_EXCELLENT	2
#define	REWARD_DENIED		3
#define	REWARD_GAUNTLET		4

// teams 
#define	TEAM_FREE			0
#define TEAM_RED			1
#define TEAM_BLUE			2
#define TEAM_SPECTATOR		3

// means of death
#define MOD_UNKNOWN			0
#define MOD_SHOTGUN			1
#define MOD_GAUNTLET		2
#define MOD_MACHINEGUN		3
#define MOD_GRENADE			4
#define MOD_GRENADE_SPLASH	5
#define MOD_ROCKET			6
#define MOD_ROCKET_SPLASH	7
#define MOD_PLASMA			8
#define MOD_PLASMA_SPLASH	9
#define MOD_RAILGUN			10
#define MOD_LIGHTNING		11
#define MOD_BFG				12
#define MOD_BFG_SPLASH		13
#define MOD_WATER			14
#define MOD_SLIME			15
#define MOD_LAVA			16
#define MOD_CRUSH			17
#define MOD_TELEFRAG		18
#define MOD_FALLING			19
#define MOD_SUICIDE			20
#define MOD_TARGET_LASER	21
#define MOD_TRIGGER_HURT	22
#define MOD_GRAPPLE			23
#define MAX_MEANS_OF_DEATH	24		// von mir fr statistics

// gitem_t->type
#define IT_BAD				0
#define IT_WEAPON			1	// EFX: rotate + upscale + minlight
#define IT_AMMO				2	// EFX: rotate
#define IT_ARMOR			3	// EFX: rotate + minlight
#define IT_HEALTH			4	// EFX: static external sphere + rotating internal
#define IT_POWERUP			5	// instant on, timer based
#define IT_HOLDABLE			6	// single use, holdable item
#define IT_TEAM				7


// entityState_t->eType
#define ET_GENERAL			0
#define ET_PLAYER			1
#define ET_ITEM				2
#define ET_MISSILE			3
#define ET_MOVER			4
#define ET_BEAM				5
#define ET_PORTAL			6
#define ET_SPEAKER			7
#define ET_PUSH_TRIGGER		8
#define ET_TELEPORT_TRIGGER	9
#define ET_INVISIBLE		10
#define ET_GRAPPLE			11	// grapple hooked on wall
#define ET_EVENTS			12	// any of the EV_* events can be added freestanding
								// by setting eType to ET_EVENTS + eventNum
								// this avoids having to set eFlags and eventNum

// g_dmflags->integer flags
#define	DF_NO_FALLING			8
#define DF_FIXED_FOV			16
#define	DF_NO_FOOTSTEPS			32

// pmove->pm_flags
#define	PMF_DUCKED			1
#define	PMF_JUMP_HELD		2
#define	PMF_BACKWARDS_JUMP	8		// go into backwards land
#define	PMF_BACKWARDS_RUN	16		// coast down to backwards run
#define	PMF_TIME_LAND		32		// pm_time is time before rejump
#define	PMF_TIME_KNOCKBACK	64		// pm_time is an air-accelerate only time
#define	PMF_TIME_WATERJUMP	256		// pm_time is waterjump
#define	PMF_RESPAWNED		512		// clear after attack and jump buttons come up
#define	PMF_USE_ITEM_HELD	1024
#define PMF_GRAPPLE_PULL	2048	// pull towards grapple location
#define PMF_FOLLOW			4096	// spectate following another player
#define PMF_SCOREBOARD		8192	// spectate as a scoreboard

#define	PMF_ALL_TIMES	(PMF_TIME_WATERJUMP|PMF_TIME_LAND|PMF_TIME_KNOCKBACK)

// player_state->stats[] indexes
#define	STAT_HEALTH			0
#define	STAT_HOLDABLE_ITEM	1
#define	STAT_WEAPONS		2		// 16 bit fields
#define	STAT_ARMOR			3				
#define	STAT_DEAD_YAW		4		// look this direction when dead (FIXME: get rid of?)
#define	STAT_CLIENTS_READ	5		// bit mask of clients wishing to exit the intermission (FIXME: configstring?)
#define	STAT_MAX_HEALTH		6		// health / armor limit, changable by handicap


// player_state->persistant[] indexes
// these fields are the only part of player_state that isn't
// cleared on respawn
#define	PERS_SCORE					0		// !!! MUST NOT CHANGE, SERVER AND GAME BOTH REFERENCE !!!
#define	PERS_HITS					1		// total points damage inflicted so damage beeps can sound on change
#define	PERS_RANK					2
#define	PERS_TEAM					3	
#define	PERS_SPAWN_COUNT			4			// incremented every respawn
#define	PERS_REWARD_COUNT			5			// incremented for each reward sound
#define	PERS_REWARD					6			// a reward_t
#define	PERS_ATTACKER				7			// clientnum of last damage inflicter
#define	PERS_KILLED					8			// count of the number of times you died
	// these were added for single player awards tracking
#define	PERS_IMPRESSIVE_COUNT		9
#define	PERS_EXCELLENT_COUNT		10	
#define	PERS_GAUNTLET_FRAG_COUNT	11
#define	PERS_ACCURACY_SHOTS			12
#define	PERS_ACCURACY_HITS			13

// gametypes
#define	GT_FFA						0			// free for all
#define	GT_TOURNAMENT				1			// one on one tournament
#define	GT_SINGLE_PLAYER			2			// single player tournament
//-- team games go after this --
#define	GT_TEAM						3			// team deathmatch
#define	GT_CTF						4			// capture the flag

// gender
#define	GENDER_MALE					0
#define	GENDER_FEMALE				1
#define	GENDER_NEUTER				2

// pmtype
#define	PM_NORMAL					0		// can accelerate and turn
#define	PM_NOCLIP					1		// noclip movement
#define	PM_SPECTATOR				2		// still run into walls
#define	PM_DEAD						3		// no acceleration or turning, but free falling
#define	PM_FREEZE					4		// stuck in place with no control
#define	PM_INTERMISSION				5		// no movement or status bar

// Weaponstate
#define	WEAPON_READY				0
#define	WEAPON_RAISING				1
#define	WEAPON_DROPPING				2
#define	WEAPON_FIRING				3


// entityState_t->event values
// entity events are for effects that take place reletive
// to an existing entities origin.  Very network efficient.

// two bits at the top of the entityState->event field
// will be incremented with each change in the event so
// that an identical event started twice in a row can
// be distinguished.  And off the value with ~EV_EVENT_BITS
// to retrieve the actual event number

#define	EV_EVENT_BIT1		0x00000100
#define	EV_EVENT_BIT2		0x00000200
#define	EV_EVENT_BITS		(EV_EVENT_BIT1|EV_EVENT_BIT2)

// entity_event_t

#define	EV_NONE						0
#define	EV_FOOTSTEP					1
#define	EV_FOOTSTEP_METAL			2
#define	EV_FOOTSPLASH				3
#define	EV_FOOTWADE					4
#define	EV_SWIM						5
#define	EV_STEP_4					6
#define	EV_STEP_8					7
#define	EV_STEP_12					8
#define	EV_STEP_16					9
#define	EV_FALL_SHORT				10
#define	EV_FALL_MEDIUM				11
#define	EV_FALL_FAR					12
#define	EV_JUMP_PAD					13	// boing sound at origin jump sound on player
#define	EV_JUMP						14
#define	EV_WATER_TOUCH				15  // foot touches
#define	EV_WATER_LEAVE				16	// foot leaves
#define	EV_WATER_UNDER				17	// head touches
#define	EV_WATER_CLEAR				18	// head leaves
#define	EV_ITEM_PICKUP				19	// normal item pickups are predictable
#define	EV_GLOBAL_ITEM_PICKUP		20  // powerup / team sounds are broadcast to everyone
#define	EV_NOAMMO					21
#define	EV_CHANGE_WEAPON			22
#define	EV_FIRE_WEAPON				23
#define	EV_USE_ITEM0				24
#define	EV_USE_ITEM1				25
#define	EV_USE_ITEM2				26
#define	EV_USE_ITEM3				27
#define	EV_USE_ITEM4				28
#define	EV_USE_ITEM5				29
#define	EV_USE_ITEM6				30
#define	EV_USE_ITEM7				31
#define	EV_USE_ITEM8				32
#define	EV_USE_ITEM9				33
#define	EV_USE_ITEM10				34
#define	EV_USE_ITEM11				35
#define	EV_USE_ITEM12				36
#define	EV_USE_ITEM13				37
#define	EV_USE_ITEM14				38
#define	EV_USE_ITEM15				39
#define	EV_ITEM_RESPAWN				40
#define	EV_ITEM_POP					41
#define	EV_PLAYER_TELEPORT_IN		42
#define	EV_PLAYER_TELEPORT_OUT		43
#define	EV_GRENADE_BOUNCE			44	// eventParm will be the soundindex
#define	EV_GENERAL_SOUND			45
#define	EV_GLOBAL_SOUND				46  // no attenuation
#define	EV_BULLET_HIT_FLESH			47
#define	EV_BULLET_HIT_WALL			48
#define	EV_MISSILE_HIT				49
#define	EV_MISSILE_MISS				50
#define	EV_RAILTRAIL				51
#define	EV_SHOTGUN					52
#define	EV_BULLET					53	// otherEntity is the shooter
#define	EV_PAIN						54
#define	EV_DEATH1					55
#define	EV_DEATH2					56
#define	EV_DEATH3					57
#define	EV_OBITUARY					58
#define	EV_POWERUP_QUAD				59
#define	EV_POWERUP_BATTLESUIT		60
#define	EV_POWERUP_REGEN			61
#define	EV_GIB_PLAYER				62	// gib a previously living player
#define	EV_DEBUG_LINE				63
#define	EV_TAUNT					64

//item numbers (make sure they are in sync with bg_itemlist in bg_misc.c)
#define MODELINDEX_ARMORSHARD		1
#define MODELINDEX_ARMORCOMBAT		2
#define MODELINDEX_ARMORBODY		3
#define MODELINDEX_HEALTHSMALL		4
#define MODELINDEX_HEALTH			5
#define MODELINDEX_HEALTHLARGE		6
#define MODELINDEX_HEALTHMEGA		7

#define MODELINDEX_GAUNTLET			8
#define MODELINDEX_SHOTGUN			9
#define MODELINDEX_MACHINEGUN		10
#define MODELINDEX_GRENADELAUNCHER	11
#define MODELINDEX_ROCKETLAUNCHER	12
#define MODELINDEX_LIGHTNING		13
#define MODELINDEX_RAILGUN			14
#define MODELINDEX_PLASMAGUN		15
#define MODELINDEX_BFG10K			16
#define MODELINDEX_GRAPPLINGHOOK	17

#define MODELINDEX_SHELLS			18
#define MODELINDEX_BULLETS			19
#define MODELINDEX_GRENADES			20
#define MODELINDEX_CELLS			21
#define MODELINDEX_LIGHTNINGAMMO	22
#define MODELINDEX_ROCKETS			23
#define MODELINDEX_SLUGS			24
#define MODELINDEX_BFGAMMO			25

#define MODELINDEX_TELEPORTER		26
#define MODELINDEX_MEDKIT			27
#define MODELINDEX_QUAD				28
#define MODELINDEX_ENVIRONMENTSUIT	29
#define MODELINDEX_HASTE			30
#define MODELINDEX_INVISIBILITY		31
#define MODELINDEX_REGEN			32
#define MODELINDEX_FLIGHT			33
#define MODELINDEX_REDFLAG			34
#define MODELINDEX_BLUEFLAG			35

// gitem_t->type
#define IT_BAD						0
#define IT_WEAPON					1	// EFX: rotate + upscale + minlight
#define IT_AMMO						2	// EFX: rotate
#define IT_ARMOR					3	// EFX: rotate + minlight
#define IT_HEALTH					4	// EFX: static external sphere + rotating internal
#define IT_POWERUP					5	// instant on, timer based
#define IT_HOLDABLE					6	// single use, holdable item
#define IT_TEAM						7   // nur in CTF

// holdable_t;
#define HI_NONE						0
#define HI_TELEPORTER				1
#define HI_MEDKIT					2
#define HI_NUM_HOLDABLE				3

// angle indexes
#define	PITCH						0		// up / down
#define	YAW							1		// left / right
#define	ROLL						2		// fall over


// game vars
#define	GAME_VERSION		"baseq3-1"

#define	DEFAULT_GRAVITY		800
#define	GIB_HEALTH			-40
#define	ARMOR_PROTECTION	0.66

#define	MAX_ITEMS			256

#define	RANK_TIED_FLAG		0x4000

#define	ITEM_RADIUS			15		// item sizes are needed for client side pickup detection

#define	LIGHTNING_RANGE		768

#define	SCORE_NOT_PRESENT	-9999	// for the CS_SCORES[12] when only one player is present

#define	VOTE_TIME			30000	// 30 seconds before vote times out


// connstate_t
#define CA_UNINITIALIZED	0
#define CA_DISCONNECTED		1 	// not talking to a server
#define CA_AUTHORIZING		2	// not used any more, was checking cd key 
#define CA_CONNECTING		3	// sending request packets to the server
#define CA_CHALLENGING		4	// sending challenge packets to the server
#define CA_CONNECTED		5	// netchan_t established, getting gamestate
#define CA_LOADING			6	// only during cgame initialization, never during main loop
#define CA_PRIMED			7	// got gamestate, waiting for first frame
#define CA_ACTIVE			8	// game views should be displayed
#define CA_CINEMATIC		9	// playing a cinematic or a static pic, not connected to a server
