/////////////////////////////////////////////
// ARGUS Copyright (C) 1999-2000 Martin Otten
// file : DemoFile.cpp
// info : class code of CDemoFile
/////////////////////////////////////////////


#include "DemoFile.h"

const DWORD END_SEQ_NUMBER = 0xFFFFFFFF;	// seqencnummer die das ender des files anzeigt

CDemoFile::CDemoFile()
{
	fHandle = NULL;
	SequenceNumber = END_SEQ_NUMBER;
}

bool CDemoFile::Open(char * filename, bool ReadOnly)	// ffnet eine DM3 Datei
{
	// falls alte offen schliesse diese
	if (fHandle!=NULL) fclose(fHandle);

	fReadOnly=ReadOnly;	// bernimm einstellung

	if (fReadOnly)
		fHandle = fopen(filename,"rb");	// ffne lesend
	else	
		fHandle = fopen(filename,"wb");	// offne schreibend

	if (fHandle)
	{
		//lies erste SeqNummer
		fread(&SequenceNumber,sizeof(SequenceNumber),1,fHandle);	
		return true;
	}
	else
		return false;	// file konnte nicht geffent werden

}

void CDemoFile::Close(void)			// schliesst eine DM3 Datei
{
	if (fHandle!=NULL)
	{
		if (!fReadOnly)
		{
			// demofiles enden mit der sequencnumber 0xFFFFFFFF
			fwrite(&END_SEQ_NUMBER,sizeof(DWORD),1,fHandle);	
		};
		fclose(fHandle);
	};
};

bool CDemoFile::EndOfFile(void)		// testet ob datei zu ende
{
	return (SequenceNumber == END_SEQ_NUMBER ) || feof(fHandle);
}

bool CDemoFile::ReadPacket(CPacket * packet)	// liest ein datenpaket
{
	// DM3 format :
	// | 4 Byte SequenceNumber | 4 Byte Lnge n | n Bytes Daten |

	// sequence nummer wurde schon gelesen
	packet->SequenceNumber = SequenceNumber ;

	// lies lnge des nchsten pakets
	fread(&packet->Length ,sizeof(DWORD),1,fHandle);

	// berspringe die 4 byte der Seq Nr
	fread(packet->Data+4,sizeof(BYTE),packet->Length,fHandle);

	// korrigiere Lnge mit seqnr
	packet->Length+=4; 

	packet->ResetPointer();

	// jetzt lies frs nchste paket die Seqnr
	fread(&SequenceNumber,sizeof(SequenceNumber),1,fHandle);	

	return true;
}

bool CDemoFile::WritePacket(CPacket * packet)	// liest ein datenpaket
{
	// schreibe im demoformat:
	// | 4 Byte SequenceNumber | 4 Byte Lnge n | n Bytes Daten |
	if (fHandle)
	{
		DWORD Length = packet->Length-4;	// bei lnge muss die seq nummer weg

		fwrite(&packet->SequenceNumber,sizeof(DWORD),1,fHandle);	
		fwrite(&Length,sizeof(DWORD),1,fHandle);
		fwrite(packet->Data+4,sizeof(BYTE),Length,fHandle);

		return true;
	}
	else
		return false;	// es war kein handle offen
}



CDemoFile::GotoSequenceNumber()
{

}

CDemoFile::GotoFirstSeqenceNumber()
{

}

