/////////////////////////////////////////////
// ARGUS Copyright (C) 1999-2000 Martin Otten
// file : packet.cpp
// info : class code of CPacket
/////////////////////////////////////////////

#include "Packet.h"
#include <memory.h> // fr memset

void CPacket::Clear(void)
{
	memset(Data,0,sizeof(Data));	// datenlschen
	Length=0;
	Reliable=false;
	BitPosition=0;	// noch kein bit gelesen
	BytePosition=4;	// da im packet am anfang die seqence nummer steht wird 4 addiert
}

void CPacket::NextFullByte(void)		// setzt den Lesezeiger auf das nchste Byte
{
	if (BitPosition)	// bit pos != 0 ?
		ReadnBits(8-BitPosition); // lese soviel bits bis neues ganzes Byte erreicht, verwerfe ergebnis
	
}

void CPacket::ResetPointer(void)	// Setzt den LeseZeiger wieder auf den Anfang
{
	BitPosition=0;	// noch kein bit gelesen
	BytePosition=4;	// da im packet am anfang die seqence nummer steht wird 4 addiert
}

bool CPacket::EndOfPacket(void)		// berprft ob der lesezeiger ber die Letzte Position gelesen hat
{
	return (BytePosition >= Length); 
}


float CPacket::ReadFloat(void)			// Liest ein Float
{
	DWORD dw=ReadnBits(32);
	return *(float*)&dw;	// typecasting auf float
}

DWORD CPacket::ReadDWord(void)			// liest ein DWord
{
	return ReadnBits(32);
}

WORD CPacket::ReadWord(void)			// liest ein word
{
	return ReadnBits(16);
}

int CPacket::ReadInt(void)			// liest ein 16 integer
{
	DWORD i = ReadnBits(16);
	if (i & NEGATION_BIT)
		return int(i ^ NEGATION_MASK);
	else
		return i;
}

BYTE CPacket::ReadByte(void)			// liest ein byte
{
	return ReadnBits(8);
}

DWORD CPacket::ReadnBits(int n)	// liest n Bits
{
	DWORD Bits,post; 
	int	  diff;

	if ((n+BitPosition)>32) // kann ich nicht alles in einem lesen ?
	{
		// komplizierter Fall, da 2 mal gelesen werden muss
		Bits = *(DWORD*)&(Data[BytePosition]);
		post = *(DWORD*)&(Data[BytePosition+4]);
		Bits>>=BitPosition;
		post<<=32-BitPosition;
		Bits |= post; // das klappt nur so schnell da keine n zwischen 24 und 31 liegen
	}
	else
	{
		// einfacher fall, da alles in einem DWord gelesen werden kann
		Bits = *(DWORD*)&Data[BytePosition];
		Bits>>= BitPosition; 
		Bits<<=(diff=32-n);
		Bits>>=(diff);

	};

	BytePosition+= n>>3;
	BitPosition+=n&7;
	if (BitPosition>=8)
	{
		BitPosition&=7;
		BytePosition++;
	}

	return Bits;	
}


float CPacket::ReadPackedFloat(void)
{	int Integer;
	if (ReadBit())	
		return ReadFloat();	// wenn Bit gesetzt ganzen 32 Bit Float lesen
	else	
	{
		Integer = ReadnBits(13) - 4096;	// -4096 ist die kleinste mglich negative zahl
		return (float)Integer;				// explizite Typeumwandlung
	}
}

bool CPacket::ReadBit(void)			// liest 1 bit
{
	bool Bit = (Data[BytePosition]>>BitPosition) & 1;

	if ((++BitPosition)==8) // zeiger 1 bit weiter und testen ob bytegrenze berschritten
	{
		BitPosition=0;
		BytePosition++;
	}
	
	return Bit;
	
}

int CPacket::ReadString(char * string)
{
	DWORD zaehler=0;
	
	// TODO aus sicherheitgrnden knnte hier nen endpaeckt? rein	
	while((string[zaehler++]=ReadByte()) && (zaehler<0x7FF));
	
	return zaehler;	// gib lnge des Strings Wieder zurck
}

