/////////////////////////////////////////////
// ARGUS Copyright (C) 1999-2000 Martin Otten
// file : packet.h
// info : class definition of CPacket
/////////////////////////////////////////////

#if !defined(PACKET_H_INCLUDED)
#define PACKET_H_INCLUDED

#include "types.h"

// constants for packet
#define MAX_PACKET_LENGTH	16768		// maximale paketlnge
#define NEGATION_BIT		0x8000
#define NEGATION_MASK		0xFFFF0000

class CPacket
{

public:

	// member variable
	union	// sequenc number sind immer die ersten 4 byte im paket
	{
		DWORD	SequenceNumber;				// die fhrende Sequence Nummer im Packet	
		BYTE	Data[MAX_PACKET_LENGTH];	// Datenbuffer fr den eigentlichen Packetinhalt
	};

	int		Length;						// lnge des Pakets in Byte wird nur beim anlegen geschrieben
	BYTE	BitPosition;				// Aktuelle Bit Position im aktuellen Byte, erstes Bit=Nr0
	DWORD	BytePosition;
	bool	Reliable;					// Bit 32 in Sequence number gesetzt ???
			
	// member Functions
	void	NextFullByte(void);		// setzt den Lesezeiger auf das nchste Byte
	void	ResetPointer(void);		// Setzt den LeseZeiger wieder auf den Anfang
	bool	EndOfPacket(void);		// berprft ob der lesezeiger ber die Letzte Position gelesen hat
	void	Clear(void);			// lscht den inhalt alle variabeln und daten

	float	ReadFloat(void);		// Liest ein Float
	DWORD	ReadDWord(void);		// liest ein DWord
	WORD	ReadWord(void);			// liest ein word
	BYTE	ReadByte(void);			// liest ein byte
	DWORD	ReadnBits(int n);		// liest n Bits	,maximal 32 mehr passen in ein DWORD nicht rein
	int		ReadInt(void);			// liest 16 bit integer
	bool	ReadBit(void);			// liest 1 bit
	int		ReadString(char * string);	// liest Nullterminierten String und gibt lnge zurck
	float	ReadPackedFloat(void);	// liest die spezielle Quake Floats 

};


#endif 
