// ViewGraph.cpp : implementation file
//

#include "stdafx.h"
#include "argus.h"
#include "ViewGraph.h"
#include "cgame.h"
#include "statistics.h"
#include "options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewGraph dialog


CViewGraph::CViewGraph(CWnd* pParent /*=NULL*/)
	: CDialog(CViewGraph::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewGraph)
	m_Player1 = 0;
	m_Player2 = 0;
	m_Player3 = 0;
	m_Player4 = 0;
	m_ValueSource1 = 0;
	m_ValueSource2 = 0;
	//}}AFX_DATA_INIT

	m_BlackPen = CreatePen(PS_SOLID,1,0x000000);
	m_GreenPen = CreatePen(PS_SOLID,1,0x00ff00);
	m_DarkGreenPen = CreatePen(PS_SOLID,1,0x008800);

	m_BlackBrush = CreateSolidBrush(0x000000);

	// farben der graphen setzen
	m_GraphColors[0]= 0xff0000;
	m_GraphColors[1]= 0xffff00;
	m_GraphColors[2]= 0x0000ff;
	m_GraphColors[3]= 0xff00ff;
	
	
	m_GraphPens[0] = CreatePen(PS_SOLID,1,m_GraphColors[0]);
	m_GraphPens[1] = CreatePen(PS_DOT,1,m_GraphColors[0]);
	m_GraphPens[2] = CreatePen(PS_SOLID,1,m_GraphColors[1]);
	m_GraphPens[3] = CreatePen(PS_DOT,1,m_GraphColors[1]);
	m_GraphPens[4] = CreatePen(PS_SOLID,1,m_GraphColors[2]);
	m_GraphPens[5] = CreatePen(PS_DOT,1,m_GraphColors[2]);
	m_GraphPens[6] = CreatePen(PS_SOLID,1,m_GraphColors[3]);
	m_GraphPens[7] = CreatePen(PS_DOT,1,m_GraphColors[4]);

	m_SmallFont = (HFONT) GetStockObject(ANSI_VAR_FONT); 
	

}


void CViewGraph::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewGraph)
	DDX_Control(pDX, IDC_PLAYER4, m_Player4Ctrl);
	DDX_Control(pDX, IDC_PLAYER3, m_Player3Ctrl);
	DDX_Control(pDX, IDC_PLAYER2, m_Player2Ctrl);
	DDX_Control(pDX, IDC_PLAYER1, m_Player1Ctrl);
	DDX_CBIndex(pDX, IDC_PLAYER1, m_Player1);
	DDX_CBIndex(pDX, IDC_PLAYER2, m_Player2);
	DDX_CBIndex(pDX, IDC_PLAYER3, m_Player3);
	DDX_CBIndex(pDX, IDC_PLAYER4, m_Player4);
	DDX_CBIndex(pDX, IDC_SOURCEVALUE1, m_ValueSource1);
	DDX_CBIndex(pDX, IDC_SOURCEVALUE2, m_ValueSource2);
	DDX_CBIndex(pDX, IDC_SAMPLERATE, g_Options.GraphSamples);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewGraph, CDialog)
	//{{AFX_MSG_MAP(CViewGraph)
	ON_CBN_SELCHANGE(IDC_PLAYER1, OnSelchangePlayerValues)
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_PLAYER2, OnSelchangePlayerValues)
	ON_CBN_SELCHANGE(IDC_PLAYER3, OnSelchangePlayerValues)
	ON_CBN_SELCHANGE(IDC_PLAYER4, OnSelchangePlayerValues)
	ON_CBN_SELCHANGE(IDC_SOURCEVALUE1, OnSelchangeValueSource)
	ON_CBN_SELCHANGE(IDC_SOURCEVALUE2, OnSelchangeValueSource)
	ON_CBN_SELCHANGE(IDC_SAMPLERATE, OnSelchangeValueSource)
	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewGraph message handlers

void CViewGraph::UpdateView()
{
	int index,number;
	if (g_cgs.PlayerInfoUpdate)	// mssen allgemeine Spieldaten erneuert werden (namen, maps usw)
	{
		// alle inhalte zurcksetzen
		m_Player1Ctrl.ResetContent();
		m_Player2Ctrl.ResetContent();
		m_Player3Ctrl.ResetContent();
		m_Player4Ctrl.ResetContent();

		// den NONE spieler hinzufgen
		m_Player1Ctrl.AddString("None");
		m_Player2Ctrl.AddString("None");
		m_Player3Ctrl.AddString("None");
		m_Player4Ctrl.AddString("None");
		m_PlayerIndexToNumber[0]=-1;	// -1 = der none spieler

		if (g_statistics.GraphPlayers[0]==-1)	m_Player1Ctrl.SetCurSel(0);
		if (g_statistics.GraphPlayers[1]==-1)	m_Player2Ctrl.SetCurSel(0);
		if (g_statistics.GraphPlayers[2]==-1)	m_Player3Ctrl.SetCurSel(0);
		if (g_statistics.GraphPlayers[3]==-1)	m_Player4Ctrl.SetCurSel(0);

		index=1;
		// erstelle liste mit neuen spielern
		for (number=0;number<MAX_CLIENTS;number++)
		if(g_cgs.clientinfo[number].used && number!=g_cgs.ArgusPlayerNum)
		{
			m_Player1Ctrl.AddString(g_cgs.clientinfo[number].name);
			m_Player2Ctrl.AddString(g_cgs.clientinfo[number].name);
			m_Player3Ctrl.AddString(g_cgs.clientinfo[number].name);
			m_Player4Ctrl.AddString(g_cgs.clientinfo[number].name);

			m_PlayerIndexToNumber[index]=number;	// merke dir zu welchem index welche spielernummer gehrt
			if (g_statistics.GraphPlayers[0]==number)	m_Player1Ctrl.SetCurSel(index);
			if (g_statistics.GraphPlayers[1]==number)	m_Player2Ctrl.SetCurSel(index);
			if (g_statistics.GraphPlayers[2]==number)	m_Player3Ctrl.SetCurSel(index);
			if (g_statistics.GraphPlayers[3]==number)	m_Player4Ctrl.SetCurSel(index);

			
			index++;	// index erhhen
		}

		g_cgs.PlayerInfoUpdate=false;
		Invalidate(false);
	}
	else
		InvalidateRect(&m_GraphRect,false);

	
}

void CViewGraph::OnSelchangePlayerValues() 
{
	UpdateData(true);	// hole neue werte aus formular
	if (m_PlayerIndexToNumber[m_Player1]!=g_statistics.GraphPlayers[0])
		StatisticGraphNewPlayer(0,m_PlayerIndexToNumber[m_Player1]);

	if (m_PlayerIndexToNumber[m_Player2]!=g_statistics.GraphPlayers[1])
		StatisticGraphNewPlayer(1,m_PlayerIndexToNumber[m_Player2]);

	if (m_PlayerIndexToNumber[m_Player3]!=g_statistics.GraphPlayers[2])
		StatisticGraphNewPlayer(2,m_PlayerIndexToNumber[m_Player3]);

	if (m_PlayerIndexToNumber[m_Player4]!=g_statistics.GraphPlayers[3])
		StatisticGraphNewPlayer(3,m_PlayerIndexToNumber[m_Player4]);

	
}

void CViewGraph::OnSelchangeValueSource() 
{
	UpdateData(true);	// hole neue werte aus formular
	if (m_ValueSource1!=g_statistics.GraphValueSource[0])
		StatisticGraphNewValue(0,m_ValueSource1);

	if (m_ValueSource2!=g_statistics.GraphValueSource[1])
		StatisticGraphNewValue(1,m_ValueSource2);

	
}

void CViewGraph::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	int min,sek,time,i,x,track,sample,actPos,LastSample,ActualSample;
	char TimeString[255];
	 
	
	//m_hGraphPos = ::GetDlgItem(this->GetSafeHwnd(),IDC_GRAPHBACK);	
	m_hGraphDC=::BeginPaint(m_hGraphPos,&m_ps);

	SetTextColor(m_hBufferDC,0x0ff00);	// gner text

	// delet background
	SelectObject(m_hBufferDC,m_BlackPen);
	SelectObject(m_hBufferDC,m_BlackBrush);

	// lsche zeichenflche
	Rectangle(m_hBufferDC,0,0,GRAPH_SAMPLES,300);

	// draw grid
	
	// dunkles hintergrund grid
	SelectObject(m_hBufferDC,m_DarkGreenPen);
	for (x=250;x>-50;x-=25)
	{
		MoveToEx(m_hBufferDC,0,250-x,NULL);
		LineTo(m_hBufferDC,GRAPH_SAMPLES,250-x);
	}

	for (x=25-(g_statistics.GraphPos % 25);x<GRAPH_SAMPLES;x+=25)
	{
		MoveToEx(m_hBufferDC,x,0,NULL);
		LineTo(m_hBufferDC,x,300);
	}

	

	SelectObject(m_hBufferDC,m_GreenPen);	// helles grn fr hauptlinien
	// null linie
		
	MoveToEx(m_hBufferDC,0,250-0,NULL);
	LineTo(m_hBufferDC,GRAPH_SAMPLES,250-0);

	// 100 line
	MoveToEx(m_hBufferDC,0,250-100,NULL);
	LineTo(m_hBufferDC,GRAPH_SAMPLES,250-100);

	// 200 line
	MoveToEx(m_hBufferDC,0,250-200,NULL);
	LineTo(m_hBufferDC,GRAPH_SAMPLES,250-200);


	// nun alle 8 spuren zeichenen falls notwendig
	for(track=0;track<8;track++)
		if (g_statistics.GraphPlayers[track/2]!=-1)
		{
			actPos = (g_statistics.GraphPos-1) % GRAPH_SAMPLES;
			// muss eine verticale gridlinie gezeichnet werden ??
			
			SelectObject(m_hBufferDC,m_GraphPens[track]);	// spurfarbe

			LastSample=g_statistics.GraphValues[track][actPos];
			MoveToEx(m_hBufferDC,GRAPH_SAMPLES,250-LastSample,NULL);
			
			i=GRAPH_SAMPLES-1;
			
			for(sample=actPos-1;sample>=0;sample--)
			{
				// nur eine line ziehen falls sich der wert verndert hat
				ActualSample=g_statistics.GraphValues[track][sample];
				if (ActualSample!=LastSample)
				{
					LineTo(m_hBufferDC,i+1,250-LastSample);
					LineTo(m_hBufferDC,i,250-ActualSample);
					LastSample=ActualSample;
				}
				// eventuell uhrzeit zeichnen
				if (!(sample % 100))
				{
					time = g_statistics.GraphTime[sample]/ 1000;	// servertime in ms
					min = time  / 60;
					sek =  time  - min*60;
	
					sprintf(TimeString,"%u:%.2u",min,sek);
					TextOut(m_hBufferDC,i+1,275,TimeString,strlen(TimeString));
				}

				i--;

			}
			
			// war schon ein swap around ??
			if (g_statistics.GraphPos-1>=GRAPH_SAMPLES)
				for(sample=GRAPH_SAMPLES-1;sample>actPos ;sample--)
				{	ActualSample=g_statistics.GraphValues[track][sample];
					if (ActualSample!=LastSample)
					{
						LineTo(m_hBufferDC,i+1,250-LastSample);
						LineTo(m_hBufferDC,i,250-ActualSample);
						LastSample=ActualSample;
					}
					if (!(sample % 100))
					{
						time = g_statistics.GraphTime[sample]/ 1000;	// servertime in ms
						min = time  / 60;
						sek =  time  - min*60;
	
						sprintf(TimeString,"%u:%.2u",min,sek);
						TextOut(m_hBufferDC,i+1,275,TimeString,strlen(TimeString));
					}
					i--;
				}

				LineTo(m_hBufferDC,i+1,250-LastSample);
				LineTo(m_hBufferDC,i,250-ActualSample);

		} 

	// beschriftung anzeigen

	TextOut(m_hBufferDC,2, 252-0,"0",1);
	TextOut(m_hBufferDC,2, 252-100,"100",3);
	TextOut(m_hBufferDC,2, 252-200,"200",3);

	// zeichen buffer in bildschirmspeicher kopieren
	BitBlt(m_hGraphDC,0,0,GRAPH_SAMPLES,300, m_hBufferDC, 0, 0, SRCCOPY); // buffer restoren
	
	::EndPaint(m_hGraphPos,&m_ps);
	

}

BOOL CViewGraph::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_hGraphPos = ::GetDlgItem(this->GetSafeHwnd(),IDC_GRAPHBACK);	

	// hole Position und grsse der Graph Area
	::GetWindowRect(m_hGraphPos,&m_GraphRect);
	ScreenToClient(&m_GraphRect);

	m_hGraphDC=::GetDC(m_hGraphPos);
	m_hBufferBmp = CreateCompatibleBitmap(m_hGraphDC,GRAPH_SAMPLES,300);
	m_hBufferDC	= CreateCompatibleDC(m_hGraphDC); 
	SelectObject(m_hBufferDC,m_hBufferBmp);
	SetBkColor(m_hBufferDC,0x000000);
	SetBkMode(m_hBufferDC,TRANSPARENT);	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
