// ViewMap.cpp : implementation file
//

#include "stdafx.h"
#include "argus.h"
#include "ViewMap.h"
#include <math.h>		// sin, cos
#include "mathlib.h"	
#include <time.h>
#include "console.h"
#include "options.h"
#include "statistics.h"

// includes fr imagelib um JPEG zu laden
#include "bitmapimage.h"
#include "jpgdecoder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct mapinfo_s
{
	char *	name;
	int		viewx;
	int		viewy;
	int		viewz;
	int		viewdir;
} mapinfo_t;



mapinfo_t mapinfo[]=
{
	{ "q3dm0",	-274,	-541,	19732,	0},
	{ "q3dm1",	684,	1154,	15932,	0},
	{ "q3dm2",	-1553,	-1980,	14468,	0},
	{ "q3dm3",	-221,	1710,	14877,	0},
	{ "q3dm4",	-184,	283,	18646,	90},
	{ "q3dm5",	-683,	-1331,	13400,	90},
	{ "q3dm6",	-361,	-225,	21331,	0},
	{ "q3dm7",	1074,	-1099,	21898,	0},
	{ "q3dm8",	1679,	916,	20619,	90},
	{ "q3dm9",	-846,	110,	20271,	0},
	{ "q3dm10",	-28,	-194,	13302,	90},
	{ "q3dm11",	-1073,	-1144,	28755,	90},
	{ "q3dm12",	75,		-804,	27674,	0},
	{ "q3dm13",	341,	443,	15106,	90},
	{ "q3dm14",	-210,	-664,	17859,	90},
	{ "q3dm15",	-60,	-226,	23876,	0},
	{ "q3dm16",	-423,	-975,	14883,	0},
	{ "q3dm17",	904,	75,		21100,	90},
	{ "q3dm18",	186,	-160,	18015,	0},
	{ "q3dm19",	887,	-203,	21886,	90},

	{ "q3tourney1",	524,	609,	14886,	0},
	{ "q3tourney2",	-60,	441,	15543,	0},
	{ "q3tourney3",	-25,	-30,	13723,	0},
	{ "q3tourney4",	28,		-82,	12940,	0},
	{ "q3tourney5",	2092,	1996,	11466,	90},
	{ "q3tourney6",	280,	352,	18295,	0},

	{ "q3ctf1",	758,	-633,	24956,	0},
	{ "q3ctf2",	54,		-279,	29698,	90},
	{ "q3ctf3",	-51,	568,	39533,	0},
	{ "q3ctf4",	319,	287,	27261,	0}
};

int MAX_MAPS = ( sizeof(mapinfo) / sizeof(mapinfo_t ));
int	g_ViewX;		// die Position des betrachters
int	g_ViewY;
int	g_ViewZ;
int	g_ViewDir;		// blickrichtung des Betrachters

using namespace Colosseum ;
using namespace std ;

/////////////////////////////////////////////////////////////////////////////
// CViewMap dialog

CViewMap::CViewMap(CWnd* pParent /*=NULL*/)
	: CDialog(CViewMap::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewMap)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	char iconpath[1024];
	COLORREF randcolor; // zufllige farbe;

	// damit ich erkenne ab vorher schone eine map geladen war
	m_hMapBmp=NULL;
	m_hMapDC	= NULL;
	m_hBufferDC	= NULL;

	m_hBufferBmp = NULL;

	strcpy(m_MapName,"");

	g_ViewX=0;
	g_ViewY=0;
	g_ViewZ=0;
	g_ViewDir=0;
	
	// icons laden
	for (int i=1;i<bg_numItems;i++)
	{
		sprintf(iconpath,"%s\\sprites\\%s.ico",g_ArgusPath,bg_itemlist[i].classname);
		bg_itemlist[i].icon = (HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
		if (bg_itemlist[i].icon == NULL) MessageBox("Faild to load item icon !","Error");
	}
	
	srand( (unsigned)time( NULL ) );	// zufallsgenerator mit aktueller zeit starten

	for (i=0;i<MAX_CLIENTS;i++)
		m_PlayerColors[i]=((rand()&255)) + ((rand()&255))*256 + ((rand()&255))*256*256;	// zufallsfarbe

	m_PlayerColors[0] = 0xf08040;
	m_PlayerColors[1] = 0x00f000;
	m_PlayerColors[2] = 0x0000f0;
	m_PlayerColors[3] = 0xf08000;
	m_PlayerColors[4] = 0x8080f0;
	m_PlayerColors[5] = 0x8000f0;
	m_PlayerColors[6] = 0x80f080;
	m_PlayerColors[7] = 0xf00080;
	m_PlayerColors[8] = 0x0080f0;
	m_PlayerColors[9] = 0x00f0f0;
	m_PlayerColors[10] = 0x408080;
	m_PlayerColors[11] = 0xf04080;
	m_PlayerColors[12] = 0xf000f0;
	m_PlayerColors[13] = 0xf08080;
	m_PlayerColors[14] = 0x8040f0;
	m_PlayerColors[15] = 0x808080;
	m_PlayerColors[16] = 0xf0f0f0;

	m_TeamColors[TEAM_FREE] = 0x00ff00;	// grn
	m_TeamColors[TEAM_RED]	= 0x0000ff;
	m_TeamColors[TEAM_BLUE]	= 0xff2200;
	m_TeamColors[TEAM_SPECTATOR] = 0xffffff;	// weiss

	m_TeamBrushes[TEAM_FREE] = CreateSolidBrush(m_TeamColors[TEAM_FREE]);
	m_TeamBrushes[TEAM_RED] = CreateSolidBrush(m_TeamColors[TEAM_RED]);
	m_TeamBrushes[TEAM_BLUE] = CreateSolidBrush(m_TeamColors[TEAM_BLUE]);
	m_TeamBrushes[TEAM_SPECTATOR] = CreateSolidBrush(m_TeamColors[TEAM_SPECTATOR]);


	for (i=0;i<MAX_CLIENTS;i++)
		m_PlayerBrushes[i]=CreateSolidBrush(m_PlayerColors[i]);
		
	m_BlackBrush = CreateSolidBrush(0x000000);

	m_WhitePen = CreatePen(PS_SOLID,3,0xFFFFFF);
	m_NoPen	= CreatePen(PS_NULL,0,0x000000);
	m_BlackPen = CreatePen(PS_SOLID,1,0x000000);

	m_WeaponPens[WP_NONE]=				CreatePen(PS_NULL, 0,0x000000);	// none
	m_WeaponPens[WP_GAUNTLET]=			CreatePen(PS_SOLID,3,0xFFD800);
	m_WeaponPens[WP_MACHINEGUN]=		CreatePen(PS_SOLID,3,0x00FFFF);
	m_WeaponPens[WP_SHOTGUN]=			CreatePen(PS_SOLID,3,0x007DFF);
	m_WeaponPens[WP_GRENADE_LAUNCHER]=	CreatePen(PS_SOLID,3,0x129002);
	m_WeaponPens[WP_ROCKET_LAUNCHER]=	CreatePen(PS_SOLID,3,0x0000FF);
	m_WeaponPens[WP_LIGHTNING]=			CreatePen(PS_SOLID,3,0xBAFFFF);
	m_WeaponPens[WP_RAILGUN]=			CreatePen(PS_SOLID,3,0x01E802);
	m_WeaponPens[WP_PLASMAGUN]=			CreatePen(PS_SOLID,3,0xFF01C6);
	m_WeaponPens[WP_BFG]=				CreatePen(PS_SOLID,3,0xFF5A01);
	m_WeaponPens[WP_GRAPPLING_HOOK]=	CreatePen(PS_SOLID,3,0x95C900);

	m_WeaponFirePens[WP_NONE]=				CreatePen(PS_NULL, 0,~0xFF000000);	// none
	m_WeaponFirePens[WP_GAUNTLET]=			CreatePen(PS_SOLID,3,~0xFFFFD800);
	m_WeaponFirePens[WP_MACHINEGUN]=		CreatePen(PS_SOLID,3,~0xFF00FFFF);
	m_WeaponFirePens[WP_SHOTGUN]=			CreatePen(PS_SOLID,3,~0xFF007DFF);
	m_WeaponFirePens[WP_GRENADE_LAUNCHER]=	CreatePen(PS_SOLID,3,~0xFF129002);
	m_WeaponFirePens[WP_ROCKET_LAUNCHER]=	CreatePen(PS_SOLID,3,~0xFF0000FF);
	m_WeaponFirePens[WP_LIGHTNING]=			CreatePen(PS_SOLID,3,~0xFFBAFFFF);
	m_WeaponFirePens[WP_RAILGUN]=			CreatePen(PS_SOLID,3,~0xFF01E802);
	m_WeaponFirePens[WP_PLASMAGUN]=			CreatePen(PS_SOLID,3,~0xFFFF01C6);
	m_WeaponFirePens[WP_BFG]=				CreatePen(PS_SOLID,3,~0xFFFF5A01);
	m_WeaponFirePens[WP_GRAPPLING_HOOK]=	CreatePen(PS_SOLID,3,~0xFF95C900);

	m_PowerUpPens[PW_QUAD]=			CreatePen(PS_SOLID,2,RGB(0,215,228));
	m_PowerUpPens[PW_BATTLESUIT]=	CreatePen(PS_SOLID,2,RGB(227,150,0));
	m_PowerUpPens[PW_HASTE]=		CreatePen(PS_SOLID,2,RGB(166,208,0));
	m_PowerUpPens[PW_INVIS]=		CreatePen(PS_SOLID,2,RGB(0,0,102));
	m_PowerUpPens[PW_REGEN]=		CreatePen(PS_SOLID,2,RGB(185,9,0));
	m_PowerUpPens[PW_FLIGHT]=		CreatePen(PS_SOLID,2,RGB(171,20,142));
	m_PowerUpPens[PW_REDFLAG]=		CreatePen(PS_SOLID,2,RGB(255,0,0));
	m_PowerUpPens[PW_BLUEFLAG]=		CreatePen(PS_SOLID,2,RGB(0,34,255));


	m_SmallFont = (HFONT) GetStockObject(ANSI_VAR_FONT); 

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"medal_excellent.ico");
	m_Sprites[SPRITE_EXCELLENT]=	(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_EXCELLENT] == NULL) MessageBox("Faild to load SPRITE_EXCELLENT icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"medal_gauntlet.ico");
	m_Sprites[SPRITE_GAUNTLET]=		(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_GAUNTLET] == NULL) MessageBox("Faild to load SPRITE_GAUNTLET icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"sprite_talk.ico");
	m_Sprites[SPRITE_TALK]=			(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_TALK] == NULL) MessageBox("Faild to load SPRITE_TALK icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"sprite_net.ico");
	m_Sprites[SPRITE_CONNECTION]=	(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_CONNECTION] == NULL) MessageBox("Faild to load SPRITE_CONNECTION icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"medal_impressive.ico");
	m_Sprites[SPRITE_IMPRESSIVE]=	(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_IMPRESSIVE] == NULL) MessageBox("Faild to load SPRITE_IMPRESSIVE icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"sprite_blood.ico");
	m_Sprites[SPRITE_BLOOD]=		(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_BLOOD] == NULL) MessageBox("Faild to load SPRITE_BLOOD icon !","Error");

	sprintf(iconpath,"%s\\sprites\\%s",g_ArgusPath,"sprite_skull.ico");
	m_Sprites[SPRITE_SKULL]=		(HICON) LoadImage(NULL, iconpath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTSIZE); 
	if (m_Sprites[SPRITE_SKULL] == NULL) MessageBox("Faild to load SPRITE_SKULL icon !","Error");

	m_hIcon = LoadIcon(theApp.m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));
	
}


void CViewMap::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewMap)
	DDX_Check(pDX, IDC_CONSOLE, g_Options.MapConsole);
	DDX_Check(pDX, IDC_ITEMS, g_Options.MapItems);
	DDX_Check(pDX, IDC_NAMES, g_Options.MapNames);
	DDX_Check(pDX, IDC_TIME, g_Options.MapTimer);
	DDX_Check(pDX, IDC_TEAMCOLORS, g_Options.MapTeamColors);
	DDX_Check(pDX, IDC_TRACE, g_Options.MapTrace);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewMap, CDialog)
	//{{AFX_MSG_MAP(CViewMap)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CONSOLE, OnApply)
	ON_BN_CLICKED(IDC_ITEMS, OnApply)
	ON_BN_CLICKED(IDC_NAMES, OnApply)
	ON_BN_CLICKED(IDC_TIME, OnApply)
	ON_BN_CLICKED(IDC_TEAMCOLORS, OnApply)
	ON_BN_CLICKED(IDC_TRACE, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewMap message handlers

void CViewMap::UpdateView()
{
	if (g_cgs.ConfigStringUpdate)	// mssen allgemeine Spieldaten erneuert werden (namen, maps usw)
	{
		SetDlgItemText(IDC_MAPNAME,g_cgs.mapname);
		g_cgs.ConfigStringUpdate=false;	// alle nderungen wurden durchgefhrt
		// alles neuzeichnen
		Invalidate(false);
		
	}
	else
	  // nur die map neuzeichnen, verhindert flackern
	  InvalidateRect(&m_MapRect,false);

	
}

bool CViewMap::RestartView()
{
	int mapindex=-1;
	int i=0;
	int x,y;

	char mappath[1024];	// der komplette pfad zur map bmp

	BitmapImage image ;	// aus imagelib
	JpegDecoder decoder ;

	
	// fall karte schon geladen ->fertig
	if (!stricmp(m_MapName,g_cgs.mapname)) 
			return true;

	// die richtige map finde 
	strcpy(m_MapName,g_cgs.mapname);	// hole aktuellen mapname
	_strlwr(m_MapName);				// kovertiere zu kleinbuchstaben




	// hole aktuellen DC
	m_hMapPos  = ::GetDlgItem(this->GetSafeHwnd(),IDC_MAPPOS);	// hole dir den Whandle des Platzhalters IDC_MAPPOS
	m_hPlayerPos = ::GetDlgItem(this->GetSafeHwnd(),IDC_PLAYERS);	

	// hole Position und grsse der MapArea
	::GetWindowRect(m_hMapPos,&m_MapRect);
	ScreenToClient(&m_MapRect);

	m_hDC=::GetDC(m_hMapPos);

	for (i=0;i<MAX_MAPS;i++)
	{
		if (!strcmp(m_MapName,mapinfo[i].name))
		{
			mapindex=i;	// richtige karte gefunden
			i=MAX_MAPS;	// beende vorzeitig suchschleife
		}
	}

	if (mapindex==-1)
	{
		MessageBox("Map file not found !","Error");
		// TODO altes Mapbitmap lschen oder Unkown bitmap bild laden
		return false;
	}

	//sprintf(mappath,"%s\\maps\\%s.bmp",g_ArgusPath,mapname);	// erstelle komplette pfadname
	sprintf(mappath,"%s\\maps\\%s.jpg",g_ArgusPath,m_MapName);	// erstelle komplette pfadname
	 
	// lade das bitmap

	// bei mapwechsel entstehen speichleicher duch alte bitmaps
	// deshalb falls vorhanden alte bitmap wieder freigeben

	if (m_hMapBmp!=NULL) DeleteObject(m_hMapBmp);
	if (m_hBufferBmp!=NULL) DeleteObject(m_hBufferBmp);
  
	// m_hMapBmp = (HBITMAP) LoadImage(NULL, mappath, IMAGE_BITMAP, 640, 480, LR_LOADFROMFILE | LR_CREATEDIBSECTION); 
	m_hMapBmp = CreateCompatibleBitmap(m_hDC,640,480);


	// jpeg decoder settings
	//decoder.setProgressFunction (Progress, NULL) ;
	string is = mappath;
	try
	{
		decoder.readImageFile (is.c_str (), image) ;
	}

	catch (std::exception &ee)
	{
		MessageBox(ee.what (), "Load Map Error", MB_OK|MB_ICONERROR) ;
	}

	m_hBufferBmp = CreateCompatibleBitmap(m_hDC,640,480);
		
	// event. alte DC wieder freigeben
	if (m_hMapDC!=NULL) DeleteDC(m_hMapDC);
	if (m_hBufferDC!=NULL) DeleteDC(m_hBufferDC);
  
	// erstelle kompatiblem DC
	m_hMapDC	= CreateCompatibleDC(m_hDC); 
	m_hBufferDC	= CreateCompatibleDC(m_hDC); 
	
	// lade map,buffer in MapDC
    SelectObject(m_hMapDC, m_hMapBmp ); 
	SelectObject(m_hBufferDC,m_hBufferBmp);

	BITMAPV4HEADER imageheader ;
    imageheader.bV4Size = sizeof (BITMAPV4HEADER) ;
    imageheader.bV4Width = image.getWidth () ;
    imageheader.bV4Height = - image.getHeight () ;
    imageheader.bV4Planes = 1 ;
    imageheader.bV4BitCount = 32 ;
    imageheader.bV4V4Compression = BI_BITFIELDS ;
    imageheader.bV4SizeImage = 0 ;
    imageheader.bV4XPelsPerMeter = 0 ;
    imageheader.bV4YPelsPerMeter = 0 ;
    imageheader.bV4ClrUsed = 0 ;
    imageheader.bV4ClrImportant = 0 ;
    imageheader.bV4BlueMask = 0xFFU ;
    imageheader.bV4GreenMask = 0xFF00U ;
    imageheader.bV4RedMask = 0xFF0000U ;
    imageheader.bV4AlphaMask = 0xFF000000U ;

    SetDIBitsToDevice (m_hMapDC,
                           0,
                           0,
                           image.getWidth (),
                           image.getHeight (),
                           0,
                           0,
                           0,
                           image.getHeight (),
                           &image [0],
                           reinterpret_cast<const BITMAPINFO*>(&imageheader),
                           DIB_RGB_COLORS) ;

				
	// betracher Position setzen
	g_ViewX = mapinfo[mapindex].viewx;
	g_ViewY = mapinfo[mapindex].viewy;
	g_ViewZ = mapinfo[mapindex].viewz;
	g_ViewDir = mapinfo[mapindex].viewdir;

	// graymap erstellen
	COLORREF farbe; //0xbbggrr 
	
	memset(&m_GrayMap,0,sizeof(m_GrayMap));


	for(x=0;x<640;x++)
		for(y=0;y<480;y++)
		{	
			farbe = GetPixel(m_hMapDC,x,y);
			if (farbe)
				m_GrayMap[x][y] = ((farbe & 0xFF) + ((farbe & 0xFF00)>>8) + ((farbe & 0xFF0000)>>16) ) >>2;
			else
				m_GrayMap[x][y] = 0;

			if (m_GrayMap[x][y] > 127) 	m_GrayMap[x][y] = 127;
		}
	
	SetBkMode(m_hBufferDC,TRANSPARENT);	// damit die schrift die karte nicht zerstrt

	return true;
}

void CViewMap::OnPaint() 
{
	int i;

	CPaintDC dc(this); // obwohl er nicht gebraucht wird muss er einmal aufgerufenwerden um den rest des MFC GUI zu zeichnen
	
	if (g_cgs.snap!=NULL && m_hMapBmp!=NULL)
	{
		DrawPlayerInfo();

		m_hDC=::BeginPaint(m_hMapPos,&m_ps);

		BitBlt(m_hBufferDC,0,0,640,480, m_hMapDC, 0, 0, SRCCOPY); // buffer restoren

		SetTextColor(m_hBufferDC,0x00EE00);	// ein schne Display grn
		SelectObject(m_hBufferDC, m_SmallFont);			// kleinen Schriftart whlen
	
		// palyer trace zones einzeichnen
		if (g_Options.MapTrace)	DrawZones();
		
		// zeichne alle anderen Entities umgekehrte riehnfolge damit clients items bermalen
		for(i=MAX_GENTITIES-1;i>=0;i--)
		{
			if (g_cg_entities[i].currentValid)
				DrawEntity(&g_ringbuff[(g_cg_entities[i].currentState) & 0x7FF],g_cg_entities[i].mapx,g_cg_entities[i].mapy);
		}
		SetTextColor(m_hBufferDC,0x00EE00);	// ein schnes Display grn

		if (g_Options.MapConsole)	DrawConsole();
		if (g_Options.MapTimer)		DrawTimer();
		
		BitBlt(m_hDC,0,0,640,480, m_hBufferDC, 0, 0, SRCCOPY); // buffer restoren

		m_FireBit=!m_FireBit;	// toogle fire bit
	
	};

	::EndPaint(m_hMapPos,&m_ps);
	
}

void CViewMap::DrawEntity(entityState_t *e, int ix, int iy)
{	
	float vangle;
	int dx,dy;

	if (e->eType==ET_PLAYER)
	{
		// ::SelectObject(m_hDC,m_NoPen);

		if (! (e->eFlags & EF_DEAD))
		{
			SelectObject(m_hBufferDC,m_BlackPen);	// spieler schwarz umranden

			if (g_ViewDir==0)
				vangle=(e->apos.trBase[YAW] + 90) * M_PI_DIV_180;
			else
				vangle=e->apos.trBase[YAW] * M_PI_DIV_180;


			if (g_cgs.gametype>=GT_TEAM)
				SelectObject(m_hBufferDC,m_TeamBrushes[g_cgs.clientinfo[e->number].team]);
			else
				SelectObject(m_hBufferDC,m_PlayerBrushes[e->number]);	// setzt spielerfarbe

			// zeichnen
			Ellipse(m_hBufferDC,ix-6,iy-6,ix+6,iy+6);

			// in zone vermerken
								
			dx=cos(vangle) * 10;
			dy=sin(vangle) * 10;

			
			if (e->weapon!=WP_NONE)	// nur gltige spieler tragen eine waffe
			{	
				// zeichne PowerUps
				
				if (e->powerups & 1<<PW_QUAD) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_QUAD]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}

				if (e->powerups & 1<<PW_INVIS) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_INVIS]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}

				if (e->powerups & 1<<PW_REGEN) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_REGEN]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}

				if (e->powerups & 1<<PW_BATTLESUIT) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_BATTLESUIT]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}

				if (e->powerups & 1<<PW_FLIGHT) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_FLIGHT]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}

				if (e->powerups & 1<<PW_HASTE) 
				{
					SelectObject(m_hBufferDC,m_PowerUpPens[PW_HASTE]);
					Arc(m_hBufferDC,ix-8,iy-8,ix+8,iy+8,0,0,0,0);
				}



				if ((e->eFlags & EF_FIRING) && m_FireBit )
					SelectObject(m_hBufferDC,m_WhitePen);
				else
					SelectObject(m_hBufferDC,m_WeaponPens[e->weapon]);	// waffenfarbe whlen
			
				MoveToEx(m_hBufferDC,ix,iy,NULL);
				LineTo(m_hBufferDC,ix+dx,iy-dy);
				
				if (g_Options.MapNames)
					TextOut(m_hBufferDC,ix,iy+10, g_cgs.clientinfo[e->number].name,strlen(g_cgs.clientinfo[e->number].name));

				if (g_Options.MapTeamColors)
				{
					MoveToEx(m_hBufferDC,ix,iy,NULL);
					LineTo(m_hBufferDC,ix+dx,iy-dy);

				}
			}

			if (e->powerups & 1<<(PW_REDFLAG))	DrawIconEx(m_hBufferDC,ix-8,iy-24,bg_itemlist[MODELINDEX_REDFLAG].icon,16,16,0,0,DI_NORMAL);
			if (e->powerups & 1<<(PW_BLUEFLAG)) DrawIconEx(m_hBufferDC,ix-8,iy-24,bg_itemlist[MODELINDEX_BLUEFLAG].icon,16,16,0,0,DI_NORMAL);

			if (e->eFlags & EF_TALK)			DrawIconEx(m_hBufferDC,ix-8,iy-24,m_Sprites[SPRITE_TALK],16,16,0,0,DI_NORMAL);
			if (e->eFlags & EF_AWARD_EXCELLENT) DrawIconEx(m_hBufferDC,ix-8,iy-24,m_Sprites[SPRITE_EXCELLENT],16,16,0,0,DI_NORMAL);
			if (e->eFlags & EF_AWARD_GAUNTLET)	DrawIconEx(m_hBufferDC,ix-8,iy-24,m_Sprites[SPRITE_GAUNTLET],16,16,0,0,DI_NORMAL);
			if (e->eFlags & EF_CONNECTION)		DrawIconEx(m_hBufferDC,ix-8,iy-24,m_Sprites[SPRITE_CONNECTION],16,16,0,0,DI_NORMAL);
			if (e->eFlags & EF_AWARD_IMPRESSIVE)DrawIconEx(m_hBufferDC,ix-8,iy-24,m_Sprites[SPRITE_IMPRESSIVE],16,16,0,0,DI_NORMAL);

		}
		else
		{
			DrawIconEx(m_hBufferDC,ix-8,iy-8,m_Sprites[SPRITE_SKULL],16,16,0,0,DI_NORMAL);
		}
	};
	
	// ist es ein item und werden items gezeigt ??
	if (e->eType==ET_ITEM && g_Options.MapItems)
	{
		DrawIconEx(m_hBufferDC,ix-8,iy-8,bg_itemlist[e->modelindex].icon,16,16,0,0,DI_NORMAL);
	}
};

void CViewMap::OnApply() 
{
	// bertrage felder auch check boxen aus options werte
	UpdateData(true);
	// map neu zeichnen
	Invalidate(false);
}

void CViewMap::DrawPlayerInfo()
{
	int pos,i=0;
	int count=0;
	char string[128];

	m_hPlayerDC=::BeginPaint(m_hPlayerPos,&m_ps);

	SelectObject(m_hPlayerDC,m_BlackPen);
	SelectObject(m_hPlayerDC,m_BlackBrush);
	Rectangle(m_hPlayerDC,0,0,116,480);
	
	SelectObject(m_hPlayerDC, m_SmallFont);			// kleinen Schriftart whlen
	SetBkColor(m_hPlayerDC,0x000000);		//schawrzen hintergrund

	for (i=0;i<MAX_CLIENTS;i++)
		if(g_cgs.clientinfo[i].used && g_cgs.ArgusPlayerNum!=i)
		{
			if (g_cgs.gametype>=GT_TEAM)
				SetTextColor(m_hPlayerDC,m_TeamColors[g_cgs.clientinfo[i].team]);
			else
				SetTextColor(m_hPlayerDC,m_PlayerColors[i]);

			if (g_cgs.clientinfo[i].team==TEAM_SPECTATOR)
				sprintf(string,"SPEC %s",g_cgs.clientinfo[i].name);
			else
				sprintf(string,"%i - %s",g_cgs.clientinfo[i].score,g_cgs.clientinfo[i].name);
			
			pos = g_cgs.clientinfo[i].rank;

			if (pos<0)
				pos = i * 16;	// rank = -1, also noch nie infos darber erhalten
			else
				pos *=16;		// position wird aus rank berechnet
			
			// TextOut(m_hPlayerDC,4, 4+pos, string,strlen(string));
			ExtTextOut(m_hPlayerDC,4, 4+pos,ETO_CLIPPED,CRect(0,0,116,480),string,strlen(string),NULL);
			count++;
		}
		

	::EndPaint(m_hPlayerPos,&m_ps);
}

CViewMap::DrawConsole()
{
	char dummy[1024];
	int i,length;
	for( i=4;i>0;i--)	
	{
		length = ConsoleRead(g_Console.Line-i,dummy);
		TextOut(m_hBufferDC,4, 4+i*16,dummy,length);
	} 
}

CViewMap::DrawZones()
{
	DWORD x,y,patternx,patterny,max,team,rot,blau,lx,ly,max_blau,max_rot,blau_count,rot_count;
	COLORREF farbe; //0xbbggrr 
	COLORREF grau;
	
	max_blau=max_rot=0;
	blau_count=rot_count=0;

	/*SelectObject(m_hBufferDC,m_BlackPen);
	SelectObject(m_hBufferDC,m_BlackBrush);
	Rectangle(m_hBufferDC,0,0,640,480);*/

	for( x=0;x<80;x++)
		for(y=0;y<60;y++)
		{
			blau = g_statistics.zones[x][y][0];
			rot = g_statistics.zones[x][y][1];
			if (blau>0) { max_blau+=blau; blau_count++;};
			if (rot>0) { max_blau+=rot; blau_count++;};
		}

	if ( (blau_count<2) || (max_blau==0)) return 0; // keine daten gefunden
	
	max_blau /= (blau_count>>1);
	max_rot = max_blau;





	for( x=0;x<80;x++)
		for(y=0;y<60;y++)
		{
			blau = g_statistics.zones[x][y][0];
			rot = g_statistics.zones[x][y][1];

			blau= (blau<<7)/max_blau;
			rot = (rot<<7)/max_rot;

			/* absolute
			if (blau>rot)
			{
				rot=(rot<<7)/blau;
				blau=127;
				
			}
			else
			if (rot>blau)
			{
				blau=(blau<<7)/rot;
				rot=127;
				
			}
			else
			if (rot==0)
				rot=blau=0;
			else
				rot=blau=127;

			*/ // relative


			// 8x8 kachel zeichnen
			lx=(x<<3)+8;
			ly=(y<<3)+8;

			if (blau>127) blau=127;
			if (rot>127) rot=127;
			
			if (rot>0 || blau>0)
			{
				for (patternx=x<<3;patternx<lx;patternx++)
					for (patterny=y<<3;patterny<ly;patterny++)
					{
						grau = m_GrayMap[patternx][patterny];
						grau = (grau+rot)+(grau<<8)+((grau+blau)<<16);
						if (grau>0)	SetPixel(m_hBufferDC,patternx,patterny,grau);
					}
			}


		}
};
 

CViewMap::DrawTimer()
{
	char dummy[255];
	
	//leveltime und server start time sind unterschiedlich 
	//msec = cg.time - cgs.levelStartTime;
	DWORD st = (g_cgs.snap->serverTime - g_cgs.levelStartTime) / 1000;	// leveltime in ms

	int min = st / 60;
	int sek =  st - min*60;
	
	sprintf(dummy,"Time %u:%.2u, Packet %u",min,sek,g_cgs.processedSnapshotNum);
	TextOut(m_hBufferDC,4, 460,dummy,strlen(dummy));
}
