#if !defined(AFX_VIEWMAP_H__6C65BC56_A844_4E39_ACFB_93BC81D5728D__INCLUDED_)
#define AFX_VIEWMAP_H__6C65BC56_A844_4E39_ACFB_93BC81D5728D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ViewMap.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CViewMap dialog

#include "cgame.h"

class CViewMap : public CDialog
{
// Construction
public:
	DrawTimer();
	DrawConsole();
	DrawZones();

	void DrawPlayerInfo();
	// void DrawEntity(entityState_t * e);
	void DrawEntity(entityState_t *e, int ix, int iy);
	
	PAINTSTRUCT m_ps;	// zeichestruktur fr BeginPaint

	BYTE    m_GrayMap[640][480];
	HPEN	m_OldPen;		// der alte stift
	HPEN	m_WhitePen;	// ein weisser stift
	HPEN	m_BlackPen;	// ein schwrazer stift
	HPEN	m_NoPen;		// kein stift

	HBRUSH	m_NoBrush;	// kein brush
	HBRUSH	m_BlackBrush;	// ein schwarzer brush

	HFONT	m_SmallFont;	// ein kleiner Zeichensatz

	HDC		m_hDC;			// der zeichenkontext
	HDC		m_hMapDC;		// der DC der BMP map
	HDC		m_hBufferDC;	// der zwischenbuffer DC
	HDC		m_hPlayerDC;	// der DC fr den Player info abschnitt

	HICON	m_hIcon;
	HICON	m_Sprites[16];	// sprites (awards,talk,net,blood...);

	HWND	m_hMapPos;		// handel des Map windows
	HWND	m_hPlayerPos;		// handel des Player info windows

	RECT	m_MapRect;		// eckpositionen der Map fr invalidateRect(...)

	HBITMAP m_hMapBmp;     // Die Bilddaten der BMP Karte
	HBITMAP m_hBufferBmp;	// die Bufferbitmap

	bool m_FireBit;		// wird bei jedem frame getoggelt, damit flackern erzeugt wird

	COLORREF	m_PlayerColors[MAX_CLIENTS];	 // die farben der Spieler
	COLORREF	m_TeamColors[4];				// team farben

	HBRUSH		m_PlayerBrushes[MAX_CLIENTS];	// die brushes der spieler FFA
	HBRUSH		m_TeamBrushes[4];				// die brushes fr team play

	HPEN		m_WeaponPens[MAX_WEAPONS];		// anzeige farben der waffen
	HPEN		m_WeaponFirePens[MAX_WEAPONS];	// waffenfarbe negiert

	HPEN		m_PowerUpPens[MAX_POWERUPS];		// anzeige farben der waffen

	char		m_MapName[255];


	bool RestartView();		// ld eine neue Karte als BMP
	void UpdateView();		// nderert positionen von items, spielernamen
	CViewMap(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CViewMap)
	enum { IDD = IDD_MAP };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewMap)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CViewMap)
	afx_msg void OnPaint();
	afx_msg void OnApply();			// eine option wurde verndert
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIEWMAP_H__6C65BC56_A844_4E39_ACFB_93BC81D5728D__INCLUDED_)
