// options.cpp
#include "options.h"

SOptions g_Options;	// Programmeinstellungen

void OptionsSave()			// speichert options in registry
{
	HKEY hkey;
	DWORD dw;

	if(ERROR_SUCCESS!=RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGISTRYPATH,0,KEY_ALL_ACCESS,&hkey))
	{ 
		// erzeuge key und ffne ihne
		if (ERROR_SUCCESS!=RegCreateKeyEx(HKEY_LOCAL_MACHINE,REGISTRYPATH,0,"",0,KEY_ALL_ACCESS,NULL,&hkey,NULL))
			MessageBox(NULL,"Could not create registry key!","Error",MB_OK|MB_ICONERROR);
  	};

	// general werte
	dw=g_Options.RefreshRate;
	RegSetValueEx(hkey,"RefreshRate",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	RegSetValueEx(hkey,"AddParams",0,REG_SZ,(const BYTE*)g_Options.AddParams,strlen(g_Options.AddParams)+1);

	RegSetValueEx(hkey,"Quake3Path",0,REG_SZ,(const BYTE*)g_Options.Quake3Path,strlen(g_Options.Quake3Path)+1);

	// Debugwerte
	dw=g_Options.DebugActive;
	RegSetValueEx(hkey,"DebugActive",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.DebugShowEntities;
	RegSetValueEx(hkey,"DebugShowEntities",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.DebugShowGamestate;
	RegSetValueEx(hkey,"DebugShowGamestate",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.DebugShowPlayerinfo;
	RegSetValueEx(hkey,"DebugShowPlayerinfo",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.DebugShowPlayerstatus;
	RegSetValueEx(hkey,"DebugShowPlayerstatus",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.DebugShowServercommand;
	RegSetValueEx(hkey,"DebugShowServercommand",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	// map werte
	dw=g_Options.MapConsole;
	RegSetValueEx(hkey,"MapConsole",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.MapItems;
	RegSetValueEx(hkey,"MapItems",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.MapNames;
	RegSetValueEx(hkey,"MapNames",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.MapTeamColors;
	RegSetValueEx(hkey,"MapTeamColors",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.MapTimer;
	RegSetValueEx(hkey,"MapTimer",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	dw=g_Options.MapTrace;
	RegSetValueEx(hkey,"MapTrace",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));

	// werte fr den statistik graphen
	dw=g_Options.GraphSamples;
	RegSetValueEx(hkey,"GraphSamples",0,REG_DWORD,(const BYTE*)&dw,sizeof(dw));
	
	
	RegCloseKey(hkey);

}

void OptionsLoad()	// ld options auf regisrty
{
	DWORD buffersize = 4;	// lnge eines DWORDs in byte
	DWORD type;
	DWORD dw;
	HKEY hkey;
	if(ERROR_SUCCESS!=RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGISTRYPATH,0,KEY_ALL_ACCESS,&hkey))
	{ 
		return; 
	};

	// general werte
	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"RefreshRate",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.RefreshRate=dw;

	buffersize = sizeof(g_Options.AddParams);
	RegQueryValueEx(hkey,"AddParams",0,&type,(BYTE*)g_Options.AddParams,&buffersize);

	buffersize = sizeof(g_Options.Quake3Path);
	RegQueryValueEx(hkey,"Quake3Path",0,&type,(BYTE*)g_Options.Quake3Path,&buffersize);

	// Debugwerte
	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugActive",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugActive=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugShowEntities",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugShowEntities=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugShowGamestate",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugShowGamestate=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugShowPlayerinfo",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugShowPlayerinfo=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugShowPlayerstatus",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugShowPlayerstatus=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"DebugShowServercommand",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.DebugShowServercommand=dw;

	// map options
	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapConsole",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapConsole=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapItems",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapItems=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapNames",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapNames=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapTeamColors",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapTeamColors=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapTimer",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapTimer=dw;

	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"MapTrace",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.MapTrace=dw;

	// werte fr den statistik graphen
	buffersize = sizeof(dw);
	RegQueryValueEx(hkey,"GraphSamples",0,&type,(BYTE*)&dw,&buffersize);
	g_Options.GraphSamples=dw;


	RegCloseKey(hkey);

}
	
void OptionsDefault()	// stellt die standardeinstellungen her
{
	g_Options.DebugActive=FALSE;
	g_Options.DebugShowEntities=FALSE;
	g_Options.DebugShowGamestate=FALSE;
	g_Options.DebugShowPlayerinfo=FALSE;
	g_Options.DebugShowServercommand=FALSE;
	g_Options.DebugShowClient=FALSE;
	g_Options.DebugLogFile=FALSE;

	g_Options.RefreshRate = 0; // 0= on ervery packet

	strcpy(g_Options.Quake3Path,"C:\\quake3\\");
	strcpy(g_Options.AddParams,"+set r_mode 0 +set r_fullscreen 0");
	
	g_Options.MapConsole = TRUE;
	g_Options.MapItems = TRUE;
	g_Options.MapNames = TRUE;
	g_Options.MapTeamColors = TRUE;
	g_Options.MapTimer = TRUE;
	g_Options.MapTrace = FALSE;

	g_Options.GraphSamples = 0;
}
