// statistics.cpp
#include "statistics.h"
#include "cgame.h"
#include "options.h"

gameStatistic_t		g_statistics;	// das globale statistik objekt

void StatisticUpdateValue(statisticValue_t * sv, int newValue)
{
	sv->count++;
	if (newValue < sv->min) sv->min = newValue;
	if (newValue > sv->max) sv->max = newValue;
	sv->sum+=newValue;
	sv->current=newValue;
}

void StatisticCreateHTML(char * filename)
{
	char * GameTypeNames[] = {"Free For All","Tourney","Single Player Tourney","Team Deathmatch","Capture The Flag"};
	char * TeamNames[]={"Free","Red","Blue","Spectator"};
		
	int i=0,temp=0,total=0;	// zaehler
	int kills=0,victims,j,enemy,totaldeaths,totalfrags;
	clientInfo_t * ci;
	playerStatistic_t * ps;

	FILE * HTMLfile = fopen(filename,"wt");

	if (HTMLfile==NULL)
	{
		MessageBox(NULL,"Could not create HTML file!","Error",MB_OK|MB_ICONERROR);
		return;
	}

	fprintf(HTMLfile,"<html><head><meta http-equiv=Content-Type content=\"text/html; charset=windows-1252\">");
	fprintf(HTMLfile,"<title>Argus Quake 3 Statistics</title>");
	fprintf(HTMLfile,"</head>");
	fprintf(HTMLfile,"<body lang=EN-US link=blue vlink=purple class=\"Normal\" bgcolor=\"#ffcc99\">");
	//BODY anfang

	fprintf(HTMLfile,"<h2>ARGUS - Quake 3 Statistics</h2><br>");
	if (!g_cgs.receivedGameState)
	{
		fprintf(HTMLfile,"No statistic data avalible.<br>");
	}
	else
	{
		fprintf(HTMLfile,"<table border=0 width=100%% cellspacing=5 >");
		fprintf(HTMLfile,"<tr align = center><td><h3>General information</h3></td>");
		fprintf(HTMLfile,"<td><table width=100%% bgcolor=#eebb88 border=1 cellspacing=0 bordercolor=#000000>");
		// allgemeine map und server infos
		// <tr align=center><td>Grenade</td><td>%i</td><td>%i%%</td></tr>
		fprintf(HTMLfile,"<tr align=center><td>Map</td><td>%s ( %s )</td></tr>",g_cgs.mapname,g_cgs.message);
		fprintf(HTMLfile,"<tr align=center><td>Server</td><td>%s</td></tr>",g_cgs.sv_hostname);
		fprintf(HTMLfile,"<tr align=center><td>Gametype</td><td>%s</td></tr>",GameTypeNames[g_cgs.gametype]);
		fprintf(HTMLfile,"<tr align=center><td>DM flags</td><td>%i</td></tr>",g_cgs.dmflags);
		fprintf(HTMLfile,"<tr align=center><td>Team flags</td><td>%i</td></tr>",g_cgs.teamflags); 
		fprintf(HTMLfile,"<tr align=center><td>Frag limit</td><td>%i</td></tr>",g_cgs.fraglimit);
		fprintf(HTMLfile,"<tr align=center><td>Capture limit</td><td>%i</td></tr>",g_cgs.capturelimit);
		fprintf(HTMLfile,"<tr align=center><td>Time limit</td><td>%i min</td></tr>",g_cgs.timelimit);
		fprintf(HTMLfile,"<tr align=center><td>Max clients</td><td>%i</td></tr>",g_cgs.maxclients );
		fprintf(HTMLfile,"<tr align=center><td>Protocol</td><td>%i</td></tr>",g_cgs.protocol);
		fprintf(HTMLfile,"<tr align=center><td>Version</td><td>%s</td></tr>",g_cgs.version);
		fprintf(HTMLfile,"<tr align=center><td>Cheats</td><td>%s</td></tr>",g_cgs.sv_cheats?"Yes":"No");
		fprintf(HTMLfile,"<tr align=center><td>Pure</td><td>%s</td></tr>",g_cgs.sv_pure?"Yes":"No");
		fprintf(HTMLfile,"<tr align=center><td>Server ID</td><td>%i</td></tr>",g_cgs.sv_serverid);
		fprintf(HTMLfile,"</table></tr></table><br>");
		
		// spieler daten
		//////////////////////////////////////

		// effizienz fr alle spieler ausrechnen
		StatisticPlayerEfficiency();

		for (i=0;i<MAX_CLIENTS;i++)
			if(g_cgs.clientinfo[i].used && g_cgs.ArgusPlayerNum!=i)
			{	
				ci = &g_cgs.clientinfo[i];
				ps = &g_statistics.players[i];

				fprintf(HTMLfile,"<table width=100%% border=1 cellspacing=0 bordercolor=#000000 bgcolor=#cc9966>");
				fprintf(HTMLfile,"<tr valign=center><td><b>&nbsp;Player&nbsp;</b></td><td valign=center bgcolor=#000000><font size=+3 color=#ffcc99>&nbsp;%s&nbsp;</font></td>",ci->name);
				fprintf(HTMLfile,"<td><center><b>Team:%s &nbsp; Model:%s/%s<br>",TeamNames[ci->team],ci->modelName,ci->skinName);
				fprintf(HTMLfile,"Handicap:%i &nbsp; Color:%i</b></center></td></tr></table>",ci->handicap,ci->color);
				
				
				fprintf(HTMLfile,"<table width=100%% border=0 cellspacing=5>");
								
				// staitic values
				////////////////////////////////////////////
				fprintf(HTMLfile,"<tr align = center><td valign=top><h3>General Statistic Values:</h3></td>");

				fprintf(HTMLfile,"<td align=left><table width=100%% border=1 cellspacing=0 bordercolor=#000000 bgcolor=#eebb88><tr bgcolor=#cc9966><th>&nbsp;Value&nbsp;</th><th>&nbsp;Last&nbsp;</th><th>&nbsp;Minimum&nbsp;</th><th>&nbsp;Average&nbsp;</th><th>&nbsp;Maximum&nbsp;</th></tr>");
				if (ps->rank.count)		fprintf(HTMLfile,"<tr align=center><td>Rank</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->rank.current,ps->rank.min,(ps->rank.sum / ps->rank.count),ps->rank.max);
				if (ps->score.count)	fprintf(HTMLfile,"<tr align=center><td>Score</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->score.current,ps->score.min,(ps->score.sum / ps->score.count),ps->score.max);
				if (ps->ping.count)		fprintf(HTMLfile,"<tr align=center><td>Ping</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->ping.current,ps->ping.min,(ps->ping.sum / ps->ping.count),ps->ping.max);
				if (ps->health.count)	fprintf(HTMLfile,"<tr align=center><td>Health</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->health.current,ps->health.min,(ps->health.sum / ps->health.count),ps->health.max);
				if (ps->armor.count)	fprintf(HTMLfile,"<tr align=center><td>Armor</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->armor.current,ps->armor.min,(ps->armor.sum / ps->armor.count),ps->armor.max);
				if (ps->movement.count)	fprintf(HTMLfile,"<tr align=center><td>Speed</td><td>%i</td><td>%i</td><td>%i</td><td>%i</td></tr>",ps->movement.current,ps->movement.min,(ps->movement.sum / ps->movement.count),ps->movement.max);
				fprintf(HTMLfile,"</table></td></tr>");

				// player kills
				////////////////////////////////////
				fprintf(HTMLfile,"<tr align = center><td valign=top><h3>Enemies and Frags:</h3></td>");
				fprintf(HTMLfile,"<td align=left><table width=100%% border=1 cellspacing=0 bordercolor=#000000 bgcolor=#eebb88><tr bgcolor=#cc9966><th>&nbsp;Player&nbsp;</th><th>&nbsp;Frags&nbsp;</th><th>&nbsp;Victims&nbsp;</th></tr>");

				totalfrags=totaldeaths=0;

				for (enemy=0;enemy<MAX_CLIENTS;enemy++)
					if(g_cgs.clientinfo[enemy].used && enemy!=i && g_cgs.ArgusPlayerNum!=enemy)
					{
						kills=0;	// wie oft wurde dieser gegner gefraggt
						for (j=0;j<MAX_MEANS_OF_DEATH;j++) // alle waffenarten zusammenzhlen
							kills+=g_statistics.kills[i][enemy][j];

						victims=0;	// wie oft wurde man selbst von diesem spieler gefraggt
						for (j=0;j<MAX_MEANS_OF_DEATH;j++)	// alle waffenarten zusammenzhlen
							victims+=g_statistics.kills[enemy][i][j];

						totalfrags+=kills;
						totaldeaths+=victims;

						/*if (victims+kills) 
						{
							g = (255*kills)/(victims+kills);
							r = (255*victims)/(victims+kills);
						}
						else
							r = g = 127; */


						fprintf(HTMLfile,"<tr align=center><td>%s</td><td>%i</td><td>%i</td></tr>",g_cgs.clientinfo[enemy].name,kills,victims);
					}
				fprintf(HTMLfile,"<tr align=center><td><b>Total</b></td><td>%i</td><td>%i</td></tr>",totalfrags ,totaldeaths);
				fprintf(HTMLfile,"</table></td></tr>");
			
				// selbstmorde
				/////////////////////////////////////////////////

				total=0;
				for(temp=0;temp<MAX_MEANS_OF_DEATH;temp++)
					total+=g_statistics.kills[i][i][temp];	// alle selbstmorde zusammen zhlen

				if (total) // falls suicides waren
				{
					fprintf(HTMLfile,"<tr align = center><td valign=top><h3>Suicides:</h3></td>");
					fprintf(HTMLfile,"<td align=left><table width=100%% border=1 cellspacing=0 bgcolor=#eebb88 bordercolor=#000000><tr bgcolor=#cc9966><th>&nbsp;Suicides&nbsp;</th><th> absolute </th><th> relative </th><th> graphic </th></tr>");
    
					temp=g_statistics.kills[i][i][MOD_GRENADE_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Grenade</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=g_statistics.kills[i][i][MOD_ROCKET_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Rocket</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_PLASMA_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Plasma</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_BFG_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>BFG</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=g_statistics.kills[i][i][MOD_SUICIDE];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Suicide</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=g_statistics.kills[i][i][MOD_FALLING];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Falling</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_CRUSH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Crushed</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_WATER];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Water</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_SLIME];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Slime</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=g_statistics.kills[i][i][MOD_LAVA];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Lava</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_TARGET_LASER];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Laser</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					temp=g_statistics.kills[i][i][MOD_TRIGGER_HURT];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Wrong place</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
				
					fprintf(HTMLfile,"<tr align=center><td><b>Total</b></td><td>%i</td></tr>",total);
					fprintf(HTMLfile,"</table></td></tr>");
				}
				else
					fprintf(HTMLfile,"<tr align=center><td><h3>No suicides.</h3></td></tr>");

				fprintf(HTMLfile,"<tr align=center><td><h3>Efficiency</h3></td><td><h3>%.2f</h3></td></tr>",g_statistics.players[i].eff);

				// weapon usage
				/////////////////////////////////

				total=0;
				// alle feinde durchgehen und alle frag arten
				for (enemy=0;enemy<MAX_CLIENTS;enemy++)
					if (enemy!=i)	// keine selbstmorde mitzhlen
					for(temp=0;temp<MAX_MEANS_OF_DEATH;temp++)
					  total+=g_statistics.kills[i][enemy][temp];	// alle selbstmorde zusammen zhlen

				// total ist jetzt die gesamtzahl der bekannten suicieds

				if (total) // falls suicides waren
				{
					fprintf(HTMLfile,"<tr align = center><td valign=top><h3>Frags by Weapons</h3></td>");
					fprintf(HTMLfile,"<td align=left><table width=100%% border=1 cellspacing=0 bgcolor=#eebb88 bordercolor=#000000><tr bgcolor=#cc9966><th>&nbsp;Weapon&nbsp;</th><th> absolute </th><th> relative </th><th> graphic </th></tr>");
    
					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_GRAPPLE];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Grapple</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_GAUNTLET];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Gauntlet</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_MACHINEGUN];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Machinegun</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_SHOTGUN];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Shotgun</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_GRENADE];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Grenade (direct)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_GRENADE_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Grenade (splash)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);
					
					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_ROCKET];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Rocket (direct)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_ROCKET_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Rocket (splash)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_PLASMA];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Plasma (direct)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_PLASMA_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Plasma (splash)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_RAILGUN];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Railgun</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_LIGHTNING];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Lightning</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_BFG];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>BFG (direct)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_BFG_SPLASH];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>BFG (splash)</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					temp=0;
					for (enemy=0;enemy<MAX_CLIENTS;enemy++)
						if (enemy!=i) temp+=g_statistics.kills[i][enemy][MOD_TELEFRAG];
					if (temp) fprintf(HTMLfile,"<tr align=center><td>Telefragged</td><td>%i</td><td>%i%%</td><td><hr noshade align=left size=8 width=%i%% color=#bb8866></td></tr>",temp,(temp*100)/total,(temp*100)/total);

					fprintf(HTMLfile,"<tr align=center><td><b>Total</b></td><td>%i</td></tr>",total);
					fprintf(HTMLfile,"</table></td></tr>");
				}
				else
					fprintf(HTMLfile,"<tr align=center><td><h3>No players fragged.</h3></td></tr>",total);

				///////////////////////////////////////

				fprintf(HTMLfile,"</table><br>");


			}

		
	}

	// HTML & Body ENDE
	fprintf(HTMLfile,"</body>");
	fprintf(HTMLfile,"</html>");

	fclose(HTMLfile);

}

void StatisticInit()
{
	int i=0;
	memset(&g_statistics,0,sizeof(g_statistics));

	// es mssen alle min werte auf maxint gesetzt werden
	for (i=0;i<MAX_CLIENTS;i++)
	{
		g_statistics.players[i].armor.min=64000;
		g_statistics.players[i].ping.min=64000;
		g_statistics.players[i].score.min=64000;
	}

	g_statistics.GraphPlayers[0]=-1;	// whle spieler None
	g_statistics.GraphPlayers[1]=-1;	// whle spieler None
	g_statistics.GraphPlayers[2]=-1;	// whle spieler None
	g_statistics.GraphPlayers[3]=-1;	// whle spieler None
}

// setzt einen neuen spieler auf einere der 4 graphen
void StatisticGraphNewPlayer(int playerTrack, int playerNumber)
{
	g_statistics.GraphPlayers[playerTrack]=playerNumber;

	// lsche die alten spieler werte
	memset(&g_statistics.GraphValues[playerTrack*2][0],0,sizeof(int) * GRAPH_SAMPLES);	
	memset(&g_statistics.GraphValues[playerTrack*2+1][0],0,sizeof(int) * GRAPH_SAMPLES);	
}

void StatisticGraphNewValue(int playerTrack, int Value)
{
	// setze den neuen wert
	g_statistics.GraphValueSource[playerTrack]=Value;	

	// lsche die alten werte
	for (int i=0;i<4;i++)
		memset(&g_statistics.GraphValues[i*2+playerTrack][0],0,sizeof(int)*GRAPH_SAMPLES);	
}

// calcutates for all players actuell eff
void StatisticPlayerEfficiency()
{
	int player,enemy,weapon,totaldeaths,totalfrags,gamefrags;

	gamefrags=0;
	for (player=0;player<MAX_CLIENTS;player++)
		if (g_cgs.clientinfo[player].used)
			for (enemy=0;enemy<MAX_CLIENTS;enemy++)
				if (g_cgs.clientinfo[enemy].used)
					for (weapon=0;weapon<MAX_MEANS_OF_DEATH;weapon++) 
						gamefrags+=g_statistics.kills[player][enemy][weapon];
	// alle 
	g_statistics.TotalFrags=gamefrags;	

	for (player=0;player<MAX_CLIENTS;player++)
		if(g_cgs.clientinfo[player].used )
		{
			totalfrags=totaldeaths=0;
			
			for (enemy=0;enemy<MAX_CLIENTS;enemy++)
				if(g_cgs.clientinfo[enemy].used)
				{
					if (enemy!=player) // selbstmorde nicht zhlen
						for (weapon=0;weapon<MAX_MEANS_OF_DEATH;weapon++) // alle waffenarten zusammenzhlen
							totalfrags+=g_statistics.kills[player][enemy][weapon];
					
					for (weapon=0;weapon<MAX_MEANS_OF_DEATH;weapon++)	// alle waffenarten zusammenzhlen
						totaldeaths+=g_statistics.kills[enemy][player][weapon];
				}

			


			if (totalfrags+totaldeaths==0 )
				g_statistics.players[player].eff=float(0);
			else
				g_statistics.players[player].eff=float(float(totalfrags*100) / float(totalfrags+totaldeaths));
				//g_statistics.players[player].eff=float( float(totalfrags-totaldeaths)/float(gamefrags)  );
		};
};



void StatisticGraphUpdate()
{
	int i;
	int actPos=g_statistics.GraphPos % GRAPH_SAMPLES;	// aktuelle sample positions
	int actPlayer;						// aktueller spieler

	switch(g_Options.GraphSamples)
	{
		case 1	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+100)) return; break;	// alle 100 ms
		case 2	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+250)) return; break;	// alle 250 ms
		case 3	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+500)) return; break;	// alle 500 ms
		case 4	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+1000)) return; break;// jede sekunden
		case 5	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+2000)) return; break;// alle 2 sekunden
		case 6	: if (g_cgs.ServerTime<(g_statistics.GraphLastTime+4000)) return; break;// alle 4 sekunden
	}

	// setze zeit fr aktuelles sample
	g_statistics.GraphTime[actPos]=g_cgs.ServerTime;
	g_statistics.GraphLastTime=g_cgs.ServerTime;

	// gehe alle vier spieler durch
	for (i=0;i<4;i++)
	{
		// falls der spieler ungleich NONE (-1) ist...
		actPlayer=g_statistics.GraphPlayers[i];
		if (actPlayer!=-1)
		{

			switch(g_statistics.GraphValueSource[0])
			{
				case GS_NONE	:	g_statistics.GraphValues[i*2][actPos]=-99999;
				case GS_SCORE	:	g_statistics.GraphValues[i*2][actPos]=g_statistics.players[actPlayer].score.current;break;
				case GS_HEALTH	:	g_statistics.GraphValues[i*2][actPos]=g_statistics.players[actPlayer].health.current;break;
				case GS_ARMOR	:	g_statistics.GraphValues[i*2][actPos]=g_statistics.players[actPlayer].armor.current;break;
				case GS_PING	:	g_statistics.GraphValues[i*2][actPos]=g_statistics.players[actPlayer].ping.current;break;
				case GS_MOVEMENT:	g_statistics.GraphValues[i*2][actPos]=g_statistics.players[actPlayer].movement.current;break;
			}

			switch(g_statistics.GraphValueSource[1])
			{
				case GS_NONE	:	g_statistics.GraphValues[i*2+1][actPos]=-99999;
				case GS_SCORE	:	g_statistics.GraphValues[i*2+1][actPos]=g_statistics.players[actPlayer].score.current;break;
				case GS_HEALTH	:	g_statistics.GraphValues[i*2+1][actPos]=g_statistics.players[actPlayer].health.current;break;
				case GS_ARMOR	:	g_statistics.GraphValues[i*2+1][actPos]=g_statistics.players[actPlayer].armor.current;break;
				case GS_PING	:	g_statistics.GraphValues[i*2+1][actPos]=g_statistics.players[actPlayer].ping.current;break;
				case GS_MOVEMENT:	g_statistics.GraphValues[i*2+1][actPos]=g_statistics.players[actPlayer].movement.current;break;
			}
		}
	}

	g_statistics.GraphPos++;
	
}
